<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <!--
    Description:
    Input:
		Expects an Airola format XML file, except there may be multiple <parses> elements. Multiple <parses> elements are meged into a single element.

Example: 
 * single file:

 $ xsltproc merge-parses.xsl input.xml

 * apply to all files in current directory, indent XML elemenents, output to directory ./merged/:

	 $ ls /tmp/*.xml | xargs -I'{}' bash -c 'xsltproc merge-parses.xsl "{}" | xmllint -format - > "merged/`basename {}`"'
	    
-->
  <xsl:output method="xml" indent="no" encoding="UTF-8"/>

  <!-- catch parent -->
  <xsl:template match="sentenceanalyses">
    <xsl:copy>
      <!-- copy merged parses elements, if any -->
      <xsl:if test="parses">
        <parses>
          <xsl:apply-templates select="parses/*"/>
        </parses>
      </xsl:if>
      <!-- copy other elements -->
      <xsl:apply-templates select="*[not(self::parses)]"/>
    </xsl:copy>
  </xsl:template>

  <!-- catch all -->
  <xsl:template match="@*|node()">
    <xsl:copy>
      <xsl:apply-templates select="@*|node()"/>
    </xsl:copy>
  </xsl:template>

</xsl:stylesheet>
