#!/bin/bash

XSL=merge.xsl

TOXML_AWK='BEGIN{print "<filelist>"}; {print "<file>" $1 "</file>" }; END{print "</filelist>"}'
XSLT="xsltproc -novalid merge.xsl -"

if [ $1 == --help ]; then
	echo "Merge XML files into a single XML file"
	echo ""
	echo "Usage:  `basename $0` FILE ..."
	echo "   or:  find path -name '*.xml' | `basename $0`"
	exit 0
fi
set -e
if [ $# -eq 0 ]; then
	cat - | awk "$TOXML_AWK" | $XSLT
else
	ls -fd1 "$@" | awk "$TOXML_AWK" | $XSLT
fi
