<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<!--
	    Description:
		     Merge XML files by concatenating depth 1 elements of each XML file.

	    Input:
	     	Expects a list of XML files to merged in the following XML format:

	     	<filelist>
	     		<file>/path/to/file.xml</file>
	     		...
	     	</filelist>

	    Example: 
	     	From a linux shell:

	     	find /path/to/xml/files -name '*.xml' \
	     		| awk 'BEGIN{print "<filelist>"}; {print "<file>" $1 "</file>" }; END{print "</filelist>"}' \
	     		| xsltproc -novalid merge.xsl - \
	     		> otutput.xml
	-->
	
	<xsl:output method="xml" indent="no" encoding="UTF-8" doctype-system="fulldoc.dtd"/>
	
	<xsl:template match="/">
		<corpora>
			<xsl:apply-templates select="/filelist" />
		</corpora>
	</xsl:template>

	<xsl:template match="file">
		<!--<xsl:copy-of select="document(text())//corpus" />-->
		<xsl:copy-of select="document(text())" />
	</xsl:template>

</xsl:stylesheet>
