package org.learningformat.impl;

import org.learningformat.api.Bracketing;
import org.learningformat.api.CharOffsetMapEntry;
import org.learningformat.api.Corpus;
import org.learningformat.api.Dependency;
import org.learningformat.api.DependencyToken;
import org.learningformat.api.Document;
import org.learningformat.api.ElementFactory;
import org.learningformat.api.Entity;
import org.learningformat.api.Pair;
import org.learningformat.api.Parse;
import org.learningformat.api.Sentence;
import org.learningformat.api.Token;
import org.learningformat.api.Tokenization;

public class DefaultElementFactory extends ElementFactory {

	@Override
	public Bracketing createBracketing() {
		return new DefaultBracketing();
	}

	@Override
	public CharOffsetMapEntry createCharOffsetMapEntry() {
		return new DefaultCharOffsetMapEntry();
	}

	@Override
	public Corpus createCorpus() {
		return new DefaultCorpus();
	}

	@Override
	public Dependency createDependency() {
		return new DefaultDependency();
	}

	@Override
	public DependencyToken createDependencyToken() {
		return new DefaultDependencyToken();
	}

	@Override
	public Document createDocument() {
		return new DefaultDocument();
	}

	@Override
	public Entity createEntity() {
		return new DefaultEntity();
	}

	@Override
	public Pair createInteraction() {
		return new DefaultPair();
	}

	@Override
	public Parse createParse() {
		return new DefaultParse();
	}

	@Override
	public Sentence createSentence() {
		return new DefaultSentence();
	}

	@Override
	public Token createToken() {
		return new DefaultToken();
	}

	@Override
	public Tokenization createTokenization() {
		return new DefaultTokenization();
	}

}
