drop type if exists DeleteStatistics Cascade;

CREATE TYPE DeleteStatistics AS 
(
	output INTEGER,
	exp INTEGER,
	fold INTEGER
);


DROP FUNCTION IF EXISTS DeleteFold(integer);

CREATE FUNCTION DeleteFold
(
  myppicvfoldsid int
)
RETURNS DeleteStatistics AS
$$
DECLARE
    final DeleteStatistics;
BEGIN

delete from ppicvoutput where expid in (select ppicvid from ppicv where ppicvfoldsid = $1);
	get diagnostics final.output = ROW_COUNT;
delete from ppicv where ppicvfoldsid = $1;
	get diagnostics final.exp = ROW_COUNT;
delete from ppicvfolds where ppicvfoldsid = $1;
	get diagnostics final.fold = ROW_COUNT;

RETURN final;  
END
$$
LANGUAGE 'plpgsql'
;
comment on function DeleteFold(integer) is 
'Deletes a fold with all belonging experiments and output';

select DeleteFold(13356);
