drop view if exists AIMed_POS_DIFFIC;
drop view if exists AIMed_NEG_DIFFIC;
drop view if exists AIMed_POS_EASY;
drop view if exists AIMed_NEG_EASY;
drop view if exists AIMed_POS_NEUTRAL;
drop view if exists AIMed_NEG_NEUTRAL;

create or replace view AIMed_POS_DIFFIC as 
select cv.acc as CVacc, cl.acc as CLacc,
cv.pairlabel,cv.gt,
cv.entity1,cv.entity2,cv.entitylabel1,cv.entitylabel2,cv.be1,cv.ee1,cv.be2,cv.ee2,cv.sentencelabel,cv.blinded
from EA_CV_aimed cv
join EA_CL_aimed cl on cl.pairlabel=cv.pairlabel
where
cv.gt = 'TRUE' and cl.gt = 'TRUE' and
-- cv.gt = 'FALSE' and cl.gt = 'FALSE' and
cv.acc <.09 and cl.acc <.4
-- cv.acc >.95 and cl.acc >.72
;
-- 
create or replace view AIMed_NEG_DIFFIC as 
select cv.acc as CVacc, cl.acc as CLacc,
cv.pairlabel,cv.gt,
cv.entity1,cv.entity2,cv.entitylabel1,cv.entitylabel2,cv.be1,cv.ee1,cv.be2,cv.ee2,cv.sentencelabel,cv.blinded
from EA_CV_aimed cv
join EA_CL_aimed cl on cl.pairlabel=cv.pairlabel
where
-- cv.gt = 'TRUE' and cl.gt = 'TRUE' and
cv.gt = 'FALSE' and cl.gt = 'FALSE' and
cv.acc <.65 and cl.acc <.28
-- cv.acc >.95 and cl.acc >.72
;
-- 
-- 
create or replace view AIMed_POS_EASY as 
select cv.acc as CVacc, cl.acc as CLacc,cv.pairlabel,cv.gt,
cv.entity1,cv.entity2,cv.entitylabel1,cv.entitylabel2,cv.be1,cv.ee1,cv.be2,cv.ee2,cv.sentencelabel,cv.blinded
 from EA_CV_aimed cv
join EA_CL_aimed cl on cl.pairlabel=cv.pairlabel
where
cv.gt = 'TRUE' and cl.gt = 'TRUE' and
-- cv.gt = 'FALSE' and cl.gt = 'FALSE' and
-- cv.acc <.07 and cl.acc <.35
cv.acc >.8 and cl.acc >.95;
-- 
-- 
create or replace view AIMed_NEG_EASY as 
select cv.acc as CVacc, cl.acc as CLacc,cv.pairlabel,cv.gt,
cv.entity1,cv.entity2,cv.entitylabel1,cv.entitylabel2,cv.be1,cv.ee1,cv.be2,cv.ee2,cv.sentencelabel,cv.blinded
 from EA_CV_aimed cv
join EA_CL_aimed cl on cl.pairlabel=cv.pairlabel
where
-- cv.gt = 'TRUE' and cl.gt = 'TRUE' and
cv.gt = 'FALSE' and cl.gt = 'FALSE' and
-- cv.acc <.07 and cl.acc <.35
cv.acc >.99 and cl.acc >.9;
-- 

create or replace view AIMed_POS_NEUTRAL as 
select cv.acc as CVacc, cl.acc as CLacc,
cv.pairlabel,cv.gt,
cv.entity1,cv.entity2,cv.entitylabel1,cv.entitylabel2,cv.be1,cv.ee1,cv.be2,cv.ee2,cv.sentencelabel,cv.blinded
from EA_CV_aimed cv
join EA_CL_aimed cl on cl.pairlabel=cv.pairlabel
where
cv.gt = 'TRUE' and cl.gt = 'TRUE' and
not(cv.acc <.09 and cl.acc <.4) and
not(cv.acc >.8 and cl.acc >.95);

create or replace view AIMed_NEG_NEUTRAL as 
select cv.acc as CVacc, cl.acc as CLacc,
cv.pairlabel,cv.gt,
cv.entity1,cv.entity2,cv.entitylabel1,cv.entitylabel2,cv.be1,cv.ee1,cv.be2,cv.ee2,cv.sentencelabel,cv.blinded
from EA_CV_aimed cv
join EA_CL_aimed cl on cl.pairlabel=cv.pairlabel
where
cv.gt = 'FALSE' and cl.gt = 'FALSE' and
not(cv.acc <.65 and cl.acc <.28) and
not(cv.acc >.99 and cl.acc >.9);
-- 

-- 
-- 
-- 
-- -------- BioInfer
-- 
drop view if exists BioInfer_POS_DIFFIC;
drop view if exists BioInfer_NEG_DIFFIC;
drop view if exists BioInfer_POS_EASY;
drop view if exists BioInfer_NEG_EASY;
drop view if exists BioInfer_POS_NEUTRAL;
drop view if exists BioInfer_NEG_NEUTRAL;

create or replace view BioInfer_POS_DIFFIC as 
select cv.acc as CVacc, cl.acc as CLacc,cv.pairlabel,cv.gt,
cv.entity1,cv.entity2,cv.entitylabel1,cv.entitylabel2,cv.be1,cv.ee1,cv.be2,cv.ee2,cv.sentencelabel,cv.blinded
 from EA_CV_BioInfer cv
join EA_CL_BioInfer cl on cl.pairlabel=cv.pairlabel
where
cv.gt = 'TRUE' and cl.gt = 'TRUE' and
cv.acc <.16 and cl.acc <.08
;

create or replace view bioinfer_NEG_DIFFIC as 
select cv.acc as CVacc, cl.acc as CLacc,
cv.pairlabel,cv.gt,
cv.entity1,cv.entity2,cv.entitylabel1,cv.entitylabel2,cv.be1,cv.ee1,cv.be2,cv.ee2,cv.sentencelabel,cv.blinded
from EA_CV_bioinfer cv
join EA_CL_bioinfer cl on cl.pairlabel=cv.pairlabel
where
cv.gt = 'FALSE' and cl.gt = 'FALSE' and
cv.acc <.4 and cl.acc <.6
;

create or replace view bioinfer_POS_EASY as 
select cv.acc as CVacc, cl.acc as CLacc,cv.pairlabel,cv.gt,
cv.entity1,cv.entity2,cv.entitylabel1,cv.entitylabel2,cv.be1,cv.ee1,cv.be2,cv.ee2,cv.sentencelabel,cv.blinded
from EA_CV_bioinfer cv
join EA_CL_bioinfer cl on cl.pairlabel=cv.pairlabel
where
cv.gt = 'TRUE' and cl.gt = 'TRUE' and
cv.acc >.9 and cl.acc >.65
;

create or replace view bioinfer_NEG_EASY as 
select cv.acc as CVacc, cl.acc as CLacc,cv.pairlabel,cv.gt,
cv.entity1,cv.entity2,cv.entitylabel1,cv.entitylabel2,cv.be1,cv.ee1,cv.be2,cv.ee2,cv.sentencelabel,cv.blinded
from EA_CV_bioinfer cv
join EA_CL_bioinfer cl on cl.pairlabel=cv.pairlabel
where
cv.gt = 'FALSE' and cl.gt = 'FALSE' and
cv.acc >.99 and cl.acc >.99
;

create or replace view BioInfer_POS_NEUTRAL as 
select cv.acc as CVacc, cl.acc as CLacc,cv.pairlabel,cv.gt,
cv.entity1,cv.entity2,cv.entitylabel1,cv.entitylabel2,cv.be1,cv.ee1,cv.be2,cv.ee2,cv.sentencelabel,cv.blinded
 from EA_CV_BioInfer cv
join EA_CL_BioInfer cl on cl.pairlabel=cv.pairlabel
where
cv.gt = 'TRUE' and cl.gt = 'TRUE' and
not(cv.acc <.16 and cl.acc <.08) and
not(cv.acc >.9 and cl.acc >.65)
;

create or replace view bioinfer_NEG_NEUTRAL as 
select cv.acc as CVacc, cl.acc as CLacc,
cv.pairlabel,cv.gt,
cv.entity1,cv.entity2,cv.entitylabel1,cv.entitylabel2,cv.be1,cv.ee1,cv.be2,cv.ee2,cv.sentencelabel,cv.blinded
from EA_CV_bioinfer cv
join EA_CL_bioinfer cl on cl.pairlabel=cv.pairlabel
where
cv.gt = 'FALSE' and cl.gt = 'FALSE' and
not(cv.acc <.4 and cl.acc <.6) and
not(cv.acc >.99 and cl.acc >.99)
;


-- 
-- ---------
-- 
-- 
drop view if exists HPRD50_POS_DIFFIC;
drop view if exists HPRD50_NEG_DIFFIC;
drop view if exists HPRD50_POS_EASY;
drop view if exists HPRD50_NEG_EASY;
drop view if exists HPRD50_POS_NEUTRAL;
drop view if exists HPRD50_NEG_NEUTRAL;


create or replace view HPRD50_POS_DIFFIC as 
select cv.acc as CVacc, cl.acc as CLacc,cv.pairlabel,cv.gt,
cv.entity1,cv.entity2,cv.entitylabel1,cv.entitylabel2,cv.be1,cv.ee1,cv.be2,cv.ee2,cv.sentencelabel,cv.blinded
 from EA_CV_HPRD50 cv
join EA_CL_HPRD50 cl on cl.pairlabel=cv.pairlabel
where
cv.gt = 'TRUE' and cl.gt = 'TRUE' and
cv.acc <.3 and cl.acc <.3
;

create or replace view HPRD50_NEG_DIFFIC as 
select cv.acc as CVacc, cl.acc as CLacc,
cv.pairlabel,cv.gt,
cv.entity1,cv.entity2,cv.entitylabel1,cv.entitylabel2,cv.be1,cv.ee1,cv.be2,cv.ee2,cv.sentencelabel,cv.blinded
from EA_CV_HPRD50 cv
join EA_CL_HPRD50 cl on cl.pairlabel=cv.pairlabel
where
cv.gt = 'FALSE' and cl.gt = 'FALSE' and
cv.acc <.35 and cl.acc <.35
;

create or replace view HPRD50_POS_EASY as 
select cv.acc as CVacc, cl.acc as CLacc,cv.pairlabel,cv.gt,
cv.entity1,cv.entity2,cv.entitylabel1,cv.entitylabel2,cv.be1,cv.ee1,cv.be2,cv.ee2,cv.sentencelabel,cv.blinded
from EA_CV_HPRD50 cv
join EA_CL_HPRD50 cl on cl.pairlabel=cv.pairlabel
where
cv.gt = 'TRUE' and cl.gt = 'TRUE' and
cv.acc >.9 and cl.acc >.9
;

create or replace view HPRD50_NEG_EASY as 
select cv.acc as CVacc, cl.acc as CLacc,cv.pairlabel,cv.gt,
cv.entity1,cv.entity2,cv.entitylabel1,cv.entitylabel2,cv.be1,cv.ee1,cv.be2,cv.ee2,cv.sentencelabel,cv.blinded
from EA_CV_HPRD50 cv
join EA_CL_HPRD50 cl on cl.pairlabel=cv.pairlabel
where
cv.gt = 'FALSE' and cl.gt = 'FALSE' and
cv.acc >.9 and cl.acc >.99
;

create or replace view HPRD50_POS_NEUTRAL as 
select cv.acc as CVacc, cl.acc as CLacc,cv.pairlabel,cv.gt,
cv.entity1,cv.entity2,cv.entitylabel1,cv.entitylabel2,cv.be1,cv.ee1,cv.be2,cv.ee2,cv.sentencelabel,cv.blinded
from EA_CV_HPRD50 cv
join EA_CL_HPRD50 cl on cl.pairlabel=cv.pairlabel
where
cv.gt = 'TRUE' and cl.gt = 'TRUE' and
not(cv.acc <.3 and cl.acc <.3) and
not(cv.acc >.9 and cl.acc >.9)
;


create or replace view HPRD50_NEG_NEUTRAL as 
select cv.acc as CVacc, cl.acc as CLacc,
cv.pairlabel,cv.gt,
cv.entity1,cv.entity2,cv.entitylabel1,cv.entitylabel2,cv.be1,cv.ee1,cv.be2,cv.ee2,cv.sentencelabel,cv.blinded
from EA_CV_HPRD50 cv
join EA_CL_HPRD50 cl on cl.pairlabel=cv.pairlabel
where
cv.gt = 'FALSE' and cl.gt = 'FALSE' and
not(cv.acc <.35 and cl.acc <.35) and 
not(cv.acc >.9 and cl.acc >.99)
;

-- ------------------
-- 


drop view if exists IEPA_POS_DIFFIC;
drop view if exists IEPA_NEG_DIFFIC;
drop view if exists IEPA_POS_EASY;
drop view if exists IEPA_NEG_EASY;
drop view if exists IEPA_POS_NEUTRAL;
drop view if exists IEPA_NEG_NEUTRAL;


create or replace view IEPA_POS_DIFFIC as 
select cv.acc as CVacc, cl.acc as CLacc,cv.pairlabel,cv.gt,
cv.entity1,cv.entity2,cv.entitylabel1,cv.entitylabel2,cv.be1,cv.ee1,cv.be2,cv.ee2,cv.sentencelabel,cv.blinded
 from EA_CV_IEPA cv
join EA_CL_IEPA cl on cl.pairlabel=cv.pairlabel
where
cv.gt = 'TRUE' and cl.gt = 'TRUE' and
cv.acc <.35 and cl.acc <.15
;

create or replace view IEPA_NEG_DIFFIC as 
select cv.acc as CVacc, cl.acc as CLacc,
cv.pairlabel,cv.gt,
cv.entity1,cv.entity2,cv.entitylabel1,cv.entitylabel2,cv.be1,cv.ee1,cv.be2,cv.ee2,cv.sentencelabel,cv.blinded
from EA_CV_IEPA cv
join EA_CL_IEPA cl on cl.pairlabel=cv.pairlabel
where
cv.gt = 'FALSE' and cl.gt = 'FALSE' and
cv.acc <.35 and cl.acc <.55
;

create or replace view IEPA_POS_EASY as 
select cv.acc as CVacc, cl.acc as CLacc,cv.pairlabel,cv.gt,
cv.entity1,cv.entity2,cv.entitylabel1,cv.entitylabel2,cv.be1,cv.ee1,cv.be2,cv.ee2,cv.sentencelabel,cv.blinded
from EA_CV_IEPA cv
join EA_CL_IEPA cl on cl.pairlabel=cv.pairlabel
where
cv.gt = 'TRUE' and cl.gt = 'TRUE' and
cv.acc >.99 and cl.acc >.75
;

create or replace view IEPA_NEG_EASY as 
select cv.acc as CVacc, cl.acc as CLacc,cv.pairlabel,cv.gt,
cv.entity1,cv.entity2,cv.entitylabel1,cv.entitylabel2,cv.be1,cv.ee1,cv.be2,cv.ee2,cv.sentencelabel,cv.blinded
from EA_CV_IEPA cv
join EA_CL_IEPA cl on cl.pairlabel=cv.pairlabel
where
cv.gt = 'FALSE' and cl.gt = 'FALSE' and
cv.acc >.9 and cl.acc >.99
;

create or replace view IEPA_POS_NEUTRAL as 
select cv.acc as CVacc, cl.acc as CLacc,cv.pairlabel,cv.gt,
cv.entity1,cv.entity2,cv.entitylabel1,cv.entitylabel2,cv.be1,cv.ee1,cv.be2,cv.ee2,cv.sentencelabel,cv.blinded
 from EA_CV_IEPA cv
join EA_CL_IEPA cl on cl.pairlabel=cv.pairlabel
where
cv.gt = 'TRUE' and cl.gt = 'TRUE' and
not(cv.acc <.35 and cl.acc <.15) and 
not(cv.acc >.99 and cl.acc >.75)
;

create or replace view IEPA_NEG_NEUTRAL as 
select cv.acc as CVacc, cl.acc as CLacc,
cv.pairlabel,cv.gt,
cv.entity1,cv.entity2,cv.entitylabel1,cv.entitylabel2,cv.be1,cv.ee1,cv.be2,cv.ee2,cv.sentencelabel,cv.blinded
from EA_CV_IEPA cv
join EA_CL_IEPA cl on cl.pairlabel=cv.pairlabel
where
cv.gt = 'FALSE' and cl.gt = 'FALSE' and
not(cv.acc <.35 and cl.acc <.55) and
not(cv.acc >.9 and cl.acc >.99)
;



-- 
-- ----------
-- 

drop view if exists LLL_POS_DIFFIC;
drop view if exists LLL_NEG_DIFFIC;
drop view if exists LLL_POS_EASY;
drop view if exists LLL_NEG_EASY;
drop view if exists LLL_POS_NEUTRAL;
drop view if exists LLL_NEG_NEUTRAL;


create or replace view LLL_POS_DIFFIC as 
select cv.acc as CVacc, cl.acc as CLacc,cv.pairlabel,cv.gt,
cv.entity1,cv.entity2,cv.entitylabel1,cv.entitylabel2,cv.be1,cv.ee1,cv.be2,cv.ee2,cv.sentencelabel,cv.blinded
 from EA_CV_LLL cv
join EA_CL_LLL cl on cl.pairlabel=cv.pairlabel
where
cv.gt = 'TRUE' and cl.gt = 'TRUE' and
cv.acc <.65 and cl.acc <.2
;

create or replace view LLL_NEG_DIFFIC as 
select cv.acc as CVacc, cl.acc as CLacc,
cv.pairlabel,cv.gt,
cv.entity1,cv.entity2,cv.entitylabel1,cv.entitylabel2,cv.be1,cv.ee1,cv.be2,cv.ee2,cv.sentencelabel,cv.blinded
from EA_CV_LLL cv
join EA_CL_LLL cl on cl.pairlabel=cv.pairlabel
where
cv.gt = 'FALSE' and cl.gt = 'FALSE' and
cv.acc <.2 and cl.acc <.6
;

create or replace view LLL_POS_EASY as 
select cv.acc as CVacc, cl.acc as CLacc,cv.pairlabel,cv.gt,
cv.entity1,cv.entity2,cv.entitylabel1,cv.entitylabel2,cv.be1,cv.ee1,cv.be2,cv.ee2,cv.sentencelabel,cv.blinded
from EA_CV_LLL cv
join EA_CL_LLL cl on cl.pairlabel=cv.pairlabel
where
cv.gt = 'TRUE' and cl.gt = 'TRUE' and
cv.acc >.99 and cl.acc >.8
;

create or replace view LLL_NEG_EASY as 
select cv.acc as CVacc, cl.acc as CLacc,cv.pairlabel,cv.gt,
cv.entity1,cv.entity2,cv.entitylabel1,cv.entitylabel2,cv.be1,cv.ee1,cv.be2,cv.ee2,cv.sentencelabel,cv.blinded
from EA_CV_LLL cv
join EA_CL_LLL cl on cl.pairlabel=cv.pairlabel
where
cv.gt = 'FALSE' and cl.gt = 'FALSE' and
cv.acc >.65 and cl.acc >.99
;

create or replace view LLL_POS_NEUTRAL as 
select cv.acc as CVacc, cl.acc as CLacc,cv.pairlabel,cv.gt,
cv.entity1,cv.entity2,cv.entitylabel1,cv.entitylabel2,cv.be1,cv.ee1,cv.be2,cv.ee2,cv.sentencelabel,cv.blinded
 from EA_CV_LLL cv
join EA_CL_LLL cl on cl.pairlabel=cv.pairlabel
where
cv.gt = 'TRUE' and cl.gt = 'TRUE' and
not(cv.acc <.65 and cl.acc <.2) and
not(cv.acc >.99 and cl.acc >.8)
;

create or replace view LLL_NEG_NEUTRAL as 
select cv.acc as CVacc, cl.acc as CLacc,
cv.pairlabel,cv.gt,
cv.entity1,cv.entity2,cv.entitylabel1,cv.entitylabel2,cv.be1,cv.ee1,cv.be2,cv.ee2,cv.sentencelabel,cv.blinded
from EA_CV_LLL cv
join EA_CL_LLL cl on cl.pairlabel=cv.pairlabel
where
cv.gt = 'FALSE' and cl.gt = 'FALSE' and
not(cv.acc <.2 and cl.acc <.6) and 
not(cv.acc >.65 and cl.acc >.99)
;

-- 
----------------------
----------------------

create or replace view NEG_DIFFIC as
select * from AIMED_NEG_DIFFIC
union 
select * from BioInfer_NEG_DIFFIC
union 
select * from HPRD50_NEG_DIFFIC
union 
select * from IEPA_NEG_DIFFIC
union 
select * from LLL_NEG_DIFFIC;


create or replace view POS_DIFFIC as
select * from AIMED_POS_DIFFIC
union 
select * from BioInfer_POS_DIFFIC
union 
select * from HPRD50_POS_DIFFIC
union 
select * from IEPA_POS_DIFFIC
union 
select * from LLL_POS_DIFFIC;


create or replace view POS_EASY as
select * from AIMED_POS_EASY
union 
select * from BioInfer_POS_EASY
union 
select * from HPRD50_POS_EASY
union 
select * from IEPA_POS_EASY
union 
select * from LLL_POS_EASY;

create or replace view NEG_EASY as
select * from AIMED_NEG_EASY
union 
select * from BioInfer_NEG_EASY
union 
select * from HPRD50_NEG_EASY
union 
select * from IEPA_NEG_EASY
union 
select * from LLL_NEG_EASY;


create or replace view NEG_NEUTRAL as
select * from AIMED_NEG_NEUTRAL
union 
select * from BioInfer_NEG_NEUTRAL
union 
select * from HPRD50_NEG_NEUTRAL
union 
select * from IEPA_NEG_NEUTRAL
union 
select * from LLL_NEG_NEUTRAL;


create or replace view POS_NEUTRAL as
select * from AIMED_POS_NEUTRAL
union 
select * from BioInfer_POS_NEUTRAL
union 
select * from HPRD50_POS_NEUTRAL
union 
select * from IEPA_POS_NEUTRAL
union 
select * from LLL_POS_NEUTRAL;

create or replace view PosNegNeutral as 
select *,'D' as hardness from pos_diffic
union 
select *,'D' as hardness from neg_diffic
union 
select *,'N' as hardness from pos_neutral
union 
select *,'N' as hardness from neg_neutral
union 
select *,'E' as hardness from pos_easy
union 
select *,'E' as hardness from neg_easy
;

