-- redefine this to consider another set of experiments (e.g. all experiments)
drop view if exists evaluatedcvexperiments;
create or replace view evaluatedcvexperiments as 
SELECT ppicvid as expid from Best_CV;

drop view if exists evaluatedclexperiments;
create or replace view evaluatedclexperiments as 
SELECT ppiclid as expid from Best_CL;

drop view if exists evaluatedccexperiments;
create or replace view evaluatedccexperiments as 
SELECT ppiccid as expid from Best_CC;

drop function if exists pair_statistics(Text, Boolean);
create or replace function pair_statistics (pairLabel Text,GT Boolean) returns stats as 
'select 
	newStats(
	sum(case when a.output=TRUE and $2 = a.output then 1 else 0 end),
	sum(case when a.output=TRUE and $2 != a.output then 1 else 0 end),
	sum(case when a.output=FALSE and $2 != a.output then 1 else 0 end),
	sum(case when a.output=FALSE and $2 = a.output then 1 else 0 end)
	)
from ppiCVoutput a
inner join evaluatedcvexperiments e on e.expiD=a.expID
where pair = $1;
' language SQL stable returns null on null input;

drop function if exists morepairs_statistics_slow(Text);
create or replace function morepairs_statistics_slow (pairLabelPattern Text) returns setof pairstats as 
'select p.pairLabel, p.groundTruth, pair_statistics(p.pairLabel,p.groundTruth)
from pair p
where pairLabel LIKE $1;'
language SQL stable returns null on null input;

drop function if exists morepairs_statistics(Text);
create or replace function morepairs_statistics(pairLabelPattern Text) returns setof pairstats as 
'select p.pairLabel, p.groundTruth,
	newStats(
	sum(case when a.output=TRUE and p.GroundTruth = a.output then 1 else 0 end),
	sum(case when a.output=TRUE and p.GroundTruth != a.output then 1 else 0 end),
	sum(case when a.output=FALSE and p.GroundTruth != a.output then 1 else 0 end),
	sum(case when a.output=FALSE and p.GroundTruth = a.output then 1 else 0 end)
	)
from ppiCVoutput a
inner join evaluatedcvexperiments e on e.expiD=a.expID
inner join pair p on p.pairLabel = a.pair
where p.pairLabel LIKE $1
group by p.pairLabel, p.GroundTruth;'
language SQL stable returns null on null input;
comment on function morepairs_statistics(Text)
is 'Calculates pairstats(pairlabel,GroundTruth,tp,fp,fn,tn) for a pairlabel pattern';

drop function if exists allpairs_statistics();
create or replace function allpairs_statistics() returns setof pairstats as 
'select p.pairLabel, p.groundTruth,
	newStats(
	sum(case when a.output=TRUE and p.GroundTruth = a.output then 1 else 0 end),
	sum(case when a.output=TRUE and p.GroundTruth != a.output then 1 else 0 end),
	sum(case when a.output=FALSE and p.GroundTruth != a.output then 1 else 0 end),
	sum(case when a.output=FALSE and p.GroundTruth = a.output then 1 else 0 end)
	)
from ppiCVoutput a
inner join evaluatedcvexperiments e on e.expiD=a.expID
inner join pair p on p.pairLabel = a.pair
where p.pairLabel is not NULL
group by p.pairLabel, p.GroundTruth;'
language SQL stable returns null on null input;
comment on function allpairs_statistics()
is 'Calculates pairstats(pairlabel,GroundTruth,tp,fp,fn,tn) for all pairs';

drop function if exists cl_morepairs_statistics(Text);
create or replace function cl_morepairs_statistics(pairLabelPattern Text) returns setof pairstats as 
'select p.pairLabel, p.groundTruth,
	newStats(
	sum(case when a.output=TRUE and p.GroundTruth = a.output then 1 else 0 end),
	sum(case when a.output=TRUE and p.GroundTruth != a.output then 1 else 0 end),
	sum(case when a.output=FALSE and p.GroundTruth != a.output then 1 else 0 end),
	sum(case when a.output=FALSE and p.GroundTruth = a.output then 1 else 0 end)
	)
from ppiCLoutput a
inner join evaluatedclexperiments e on e.expiD=a.expID
inner join pair p on p.pairLabel = a.pair
where p.pairLabel LIKE $1
group by p.pairLabel, p.GroundTruth;'
language SQL stable returns null on null input;
comment on function cl_morepairs_statistics(Text)
is 'Calculates pairstats(pairlabel,GroundTruth,tp,fp,fn,tn) for a pairlabel pattern (CL eval)';


drop function if exists cl_allpairs_statistics();
create or replace function cl_allpairs_statistics() returns setof pairstats as 
'select p.pairLabel, p.groundTruth,
	newStats(
	sum(case when a.output=TRUE and p.GroundTruth = a.output then 1 else 0 end),
	sum(case when a.output=TRUE and p.GroundTruth != a.output then 1 else 0 end),
	sum(case when a.output=FALSE and p.GroundTruth != a.output then 1 else 0 end),
	sum(case when a.output=FALSE and p.GroundTruth = a.output then 1 else 0 end)
	)
from ppiCLoutput a
inner join evaluatedclexperiments e on e.expiD=a.expID
inner join pair p on p.pairLabel = a.pair
where p.pairLabel is not NULL
group by p.pairLabel, p.GroundTruth;'
language SQL stable returns null on null input;
comment on function cl_allpairs_statistics()
is 'Calculates pairstats(pairlabel,GroundTruth,tp,fp,fn,tn) for all pairs (CL eval)';

drop function if exists cc_morepairs_statistics(Text);
create or replace function cc_morepairs_statistics(pairLabelPattern Text) returns setof pairstats as 
'select p.pairLabel, p.groundTruth,
	newStats(
	sum(case when a.output=TRUE and p.GroundTruth = a.output then 1 else 0 end),
	sum(case when a.output=TRUE and p.GroundTruth != a.output then 1 else 0 end),
	sum(case when a.output=FALSE and p.GroundTruth != a.output then 1 else 0 end),
	sum(case when a.output=FALSE and p.GroundTruth = a.output then 1 else 0 end)
	)
from ppiCCoutput a
inner join evaluatedccexperiments e on e.expiD=a.expID
inner join pair p on p.pairLabel = a.pair
where p.pairLabel LIKE $1
group by p.pairLabel, p.GroundTruth;'
language SQL stable returns null on null input;
comment on function cc_morepairs_statistics(Text)
is 'Calculates pairstats(pairlabel,GroundTruth,tp,fp,fn,tn) for a pairlabel pattern (CC eval)';


drop function if exists cc_allpairs_statistics();
create or replace function cc_allpairs_statistics() returns setof pairstats as 
'select p.pairLabel, p.groundTruth,
	newStats(
	sum(case when a.output=TRUE and p.GroundTruth = a.output then 1 else 0 end),
	sum(case when a.output=TRUE and p.GroundTruth != a.output then 1 else 0 end),
	sum(case when a.output=FALSE and p.GroundTruth != a.output then 1 else 0 end),
	sum(case when a.output=FALSE and p.GroundTruth = a.output then 1 else 0 end)
	)
from ppiCCoutput a
inner join evaluatedccexperiments e on e.expiD=a.expID
inner join pair p on p.pairLabel = a.pair
where p.pairLabel is not NULL
group by p.pairLabel, p.GroundTruth;'
language SQL stable returns null on null input;
comment on function cc_allpairs_statistics()
is 'Calculates pairstats(pairlabel,GroundTruth,tp,fp,fn,tn) for all pairs (CC eval)';

 
drop function if exists morepairs_statistics_single(Text,Text);
create or replace function morepairs_statistics_single(pairLabelPattern Text,ppicvid Text) returns setof pairstats as 
'select p.pairLabel, p.groundTruth,
	newStats(
	sum(case when a.output=TRUE and p.GroundTruth = a.output then 1 else 0 end),
	sum(case when a.output=TRUE and p.GroundTruth != a.output then 1 else 0 end),
	sum(case when a.output=FALSE and p.GroundTruth != a.output then 1 else 0 end),
	sum(case when a.output=FALSE and p.GroundTruth = a.output then 1 else 0 end)
	)
from ppiCVoutput a
inner join pair p on p.pairLabel = a.pair
where p.pairLabel LIKE $1 and a.expID=$2
group by p.pairLabel, p.GroundTruth;'
language SQL stable returns null on null input;
comment on function morepairs_statistics_single(Text,Text)
is 'Calculates pairstats(pairlabel,GroundTruth,tp,fp,fn,tn) for a pairlabel pattern given a ppicvid';

-- select * from calculateextendedstats( pair_statistics('AIMed.d0.s5.p0',FALSE) );

-- All experiments with a single corpus
-- select * from (
-- 	select p.pairLabel,case when pr.groundTruth then 'TRUE' else 'FALSE' end, 
-- 	(calculateextendedstats( p.stat)).n,
-- 	(calculateextendedstats( p.stat)).tp,
-- 	(calculateextendedstats( p.stat)).fp,
-- 	(calculateextendedstats( p.stat)).fn,
-- 	(calculateextendedstats( p.stat)).tn,
-- 	(calculateextendedstats( p.stat)).acc,
-- 	e1.entityText, e2.entityText, e1.beginOffset,e1.endOffset,e2.beginOffset,e2.endOffset,
-- 	blinded_sentence(pr.pairLabel)
-- 	from morepairs_statistics('IEPA.%') as p
-- 	inner join pair pr on pr.pairLabel=p.pairLabel
-- 	inner join entity e1 on e1.entityLabel = pr.entity1
-- 	inner join entity e2 on e2.entityLabel = pr.entity2
-- 	inner join sentence s on s.label = e1.sentence )
-- as t order by acc ASC;
-- 

