DROP FUNCTION IF EXISTS modify_experiment(integer,Text);
CREATE FUNCTION modify_experiment
(
  myppicvid int,
  condition Text
)
RETURNS INT AS
$$
DECLARE
    mykernel text;
    mycorpus text;
    myfold INT;
    myparsertype text;
    myparser text;
    mykernelscript text;
    myc double precision;
    myj double precision;
    myled Text;

    modifiedKernel text;
    modifiedKernelScript text;
    newppicvid integer;

BEGIN
  SELECT INTO mykernel kernel FROM ppicv WHERE ppicvid=myppicvid;
  SELECT INTO mycorpus corpus FROM ppicv WHERE ppicvid=myppicvid;
  SELECT INTO myfold fold FROM ppicv WHERE ppicvid=myppicvid;
  SELECT INTO myparser parser FROM ppicv WHERE ppicvid=myppicvid;
  SELECT INTO myparsertype parsertype FROM ppicv WHERE ppicvid=myppicvid;
  SELECT INTO mykernelscript kernel_script FROM ppicv WHERE ppicvid=myppicvid;
  SELECT INTO myc c FROM ppicv WHERE ppicvid=myppicvid;  
  SELECT INTO myj j FROM ppicv WHERE ppicvid=myppicvid;
  SELECT INTO myled led FROM ppicv WHERE ppicvid=myppicvid;    

  SELECT INTO modifiedKernel kernel FROM ppicv WHERE ppicvid=myppicvid;
  SELECT INTO modifiedKernelScript (SELECT mykernelscript || ' ' || condition );
   
  IF EXISTS (SELECT ppicvid FROM ppicv WHERE 
	kernel is not distinct from modifiedKernel 
	and corpus is not distinct from mycorpus 
	and fold is not distinct from myfold 
	and parsertype is not distinct from myparsertype 
	and c is not distinct from myc 
	and j is not distinct from myj 
	and led is not distinct from myled
	and parser is not distinct from myparser 
	and kernel_script is not distinct from modifiedKernelScript) 
    THEN 
    RETURN (
    SELECT ppicvid FROM ppicv WHERE 
	kernel is not distinct from modifiedKernel 
	and corpus is not distinct from mycorpus 
	and fold is not distinct from myfold 
	and parsertype is not distinct from myparsertype 
	and c is not distinct from myc 
	and j is not distinct from myj 
	and led is not distinct from myled
	and parser is not distinct from myparser 
	and kernel_script is not distinct from modifiedKernelScript); /* already exists */
  END IF;

  INSERT INTO ppicv (corpus,parsertype,parser,kernel, fold, normalized,c,j,kernel_script) VALUES 
 	(mycorpus, myparsertype,myparser,modifiedKernel,myfold,'t',myc,myj,modifiedKernelScript);
	
  SELECT INTO newppicvid currval('ppiCV_ppiCVid_seq');

  INSERT INTO
    ppicvoutput (expId, pair, output, prediction)
  SELECT
    newppicvid         as expId, 
    sub.pair	      as pair,
    (case when condition = 'DisableSentenceSeparator' then 
	(case 
		when sub.output = TRUE and sub.Twosentences = TRUE then FALSE 
		else sub.output 
	end)
	else 
	(case when condition = 'FirstEntityNNModifier(true)' then 
		(case 
			when sub.output = FALSE and sub.firstentityNNmodifier = TRUE then TRUE 
			else sub.output 
		end)
	else 
		(case when condition = 'FirstEntityNNModifier(false)' then 
		(case 
			when sub.output = TRUE and sub.firstentityNNmodifier = TRUE then FALSE 
			else sub.output 
		end)
	else
		(case when condition = 'SecondEntityNNModifier(true)' then 
		(case 
			when sub.output = FALSE and sub.secondentityNNmodifier = TRUE then TRUE 
			else sub.output 
		end)
	else 
		(case when condition = 'SecondEntityNNModifier(false)' then 
		(case 
			when sub.output = TRUE and sub.secondentityNNmodifier = TRUE then FALSE 
			else sub.output 
		end)
	else 
		(case when condition = 'BothEntityNNModifier(false)' then 
		(case 
			when sub.output = TRUE and sub.secondentityNNmodifier = TRUE and sub.firstentityNNmodifier = TRUE then FALSE 
			else sub.output 
		end)
	else 
		(case when condition = 'FirstEntityINGModifier(true)' then 
		(case 
			when sub.output = FALSE and sub.firstentityINGmodifier = TRUE then TRUE
			else sub.output 
		end)
	else 
		(case when condition = 'FirstEntityINGModifier(false)' then 
		(case 
			when sub.output = TRUE and sub.FirstEntityINGModifier = TRUE then FALSE 
			else sub.output
		end)
	else
		(case when condition = 'SecondEntityINGModifier(true)' then 
		(case 
			when sub.output = FALSE and sub.SecondEntityINGModifier = TRUE then TRUE
			else sub.output  
		end)
	else 
		(case when condition = 'SecondEntityINGModifier(false)' then 
		(case 
			when sub.output = TRUE and sub.SecondEntityINGModifier = TRUE then FALSE
			else sub.output 
		end)
	else 
		(case when condition = 'BothEntityINGModifier(false)' then 
		(case 
			when sub.output = TRUE and sub.SecondEntityINGModifier = TRUE and sub.FirstEntityINGModifier = TRUE then FALSE
			else sub.output 
		end)
	else 
		(case when condition = 'BothEntityNNINGModifier(false)' then 
		(case 
			when sub.output = TRUE and (
			(sub.SecondEntityINGModifier = TRUE and sub.FirstEntityINGModifier = TRUE) or
			(sub.SecondEntityNNModifier = TRUE and sub.FirstEntityNNModifier = TRUE) or 
			(sub.SecondEntityINGModifier = TRUE and sub.FirstEntityNNModifier = TRUE) or
			(sub.SecondEntityNNModifier = TRUE and sub.FirstEntityINGModifier = TRUE))
			then FALSE
			else sub.output 
		end)
	else 
		(case when condition = 'DisableEnumeration' then 
		(case 
			when sub.output = TRUE and sub.possibleenumeration = TRUE then FALSE
			else sub.output 
		end)
	end)
	end)
	end)	
	end)
	end)	
	end)
	end)
	end)	
	end)
	end)	
	end)
	end)	
    end) as output,
    (case when condition = 'DisableSentenceSeparator' then 
	(case 
		when sub.output = TRUE and sub.Twosentences = TRUE then -10 
		else sub.prediction 
	end)
	else 
		(case when condition = 'FirstEntityNNModifier(true)' then 
		(case 
			when sub.output = FALSE and sub.firstentityNNmodifier = TRUE then 10
			else sub.prediction 
		end)
	else 
		(case when condition = 'FirstEntityNNModifier(false)' then 
		(case 
			when sub.output = TRUE and sub.firstentityNNmodifier = TRUE then -10 
			else sub.prediction
		end)
	else
		(case when condition = 'SecondEntityNNModifier(true)' then 
		(case 
			when sub.output = FALSE and sub.secondentityNNmodifier = TRUE then 10
			else sub.prediction  
		end)
	else 
		(case when condition = 'SecondEntityNNModifier(false)' then 
		(case 
			when sub.output = TRUE and sub.secondentityNNmodifier = TRUE then -10
			else sub.prediction 
		end)
	else 
		(case when condition = 'BothEntityNNModifier(false)' then 
		(case 
			when sub.output = TRUE and sub.secondentityNNmodifier = TRUE and sub.firstentityNNmodifier = TRUE then -10
			else sub.prediction 
		end)
	else 
		(case when condition = 'FirstEntityINGModifier(true)' then 
		(case 
			when sub.output = FALSE and sub.firstentityINGmodifier = TRUE then 10
			else sub.prediction 
		end)
	else 
		(case when condition = 'FirstEntityINGModifier(false)' then 
		(case 
			when sub.output = TRUE and sub.FirstEntityINGModifier = TRUE then -10 
			else sub.prediction
		end)
	else
		(case when condition = 'SecondEntityINGModifier(true)' then 
		(case 
			when sub.output = FALSE and sub.SecondEntityINGModifier = TRUE then 10
			else sub.prediction  
		end)
	else 
		(case when condition = 'SecondEntityINGModifier(false)' then 
		(case 
			when sub.output = TRUE and sub.SecondEntityINGModifier = TRUE then -10
			else sub.prediction 
		end)
	else 
		(case when condition = 'BothEntityINGModifier(false)' then 
		(case 
			when sub.output = TRUE and sub.SecondEntityINGModifier = TRUE and sub.FirstEntityINGModifier = TRUE then -10
			else sub.prediction 
		end)
	else 
		(case when condition = 'BothEntityNNINGModifier(false)' then 
		(case 
			when sub.output = TRUE and (
			(sub.SecondEntityINGModifier = TRUE and sub.FirstEntityINGModifier = TRUE) or
			(sub.SecondEntityNNModifier = TRUE and sub.FirstEntityNNModifier = TRUE) or 
			(sub.SecondEntityINGModifier = TRUE and sub.FirstEntityNNModifier = TRUE) or
			(sub.SecondEntityNNModifier = TRUE and sub.FirstEntityINGModifier = TRUE))
			then -10
			else sub.prediction 
		end)
	else 
		(case when condition = 'DisableEnumeration' then 
		(case 
			when sub.output = TRUE and sub.possibleenumeration = TRUE then -10
			else sub.prediction 
		end)
	end)
	end)
	end)	
	end)
	end)	
	end)
	end)
	end)	
	end)
	end)	
	end)
	end)	
    end) as prediction
  FROM
  (SELECT
     output,
     prediction,
     pair,
     TwoSentences,
     firstentityNNmodifier,
     secondentityNNmodifier,
     firstentityingmodifier,
     secondentityingmodifier,
     possibleenumeration
     FROM
    ppiCVoutput o
    join PairFeatures p on o.pair = p.pairLabel
    WHERE o.expid = myppicvid
   ) as sub
;

  UPDATE ppicv set 
	tp=s.tp,
	fp=s.fp, 
	fn=s.fn, 
	tn=s.tn,
	total=s.n,
	precision_=s.p,
	recall=s.r,
	f_measure=s.f,
	auc=newauc
  FROM get_statistics(newppicvid) as s, compute_auc_cv(newppicvid) as newauc
  where ppicvid=newppicvid;


  

  RETURN newppicvid; /* just created */
  
END
$$
LANGUAGE 'plpgsql'
;
comment on function modify_experiment(integer,Text) is 
'Creates a new CV experiment from $1 using the condition in $2';


DROP FUNCTION IF EXISTS modify_experiment_cl(integer,Text);
CREATE FUNCTION modify_experiment_cl
(
  myppiclid int,
  condition Text
)
RETURNS INT AS
$$
DECLARE
    mykernel text;
    mycorpus text;
    myparsertype text;
    myparser text;
    mykernelscript text;
    myc double precision;
    myj double precision;
    myled Text;

    modifiedKernel text;
    modifiedKernelScript text;
    newppiclid integer;

BEGIN
  SELECT INTO mykernel kernel FROM ppicl WHERE ppiclid=myppiclid;
  SELECT INTO mycorpus corpus FROM ppicl WHERE ppiclid=myppiclid;
  SELECT INTO myparser parser FROM ppicl WHERE ppiclid=myppiclid;
  SELECT INTO myparsertype parsertype FROM ppicl WHERE ppiclid=myppiclid;
  SELECT INTO mykernelscript kernel_script FROM ppicl WHERE ppiclid=myppiclid;
  SELECT INTO myc c FROM ppicl WHERE ppiclid=myppiclid;  
  SELECT INTO myj j FROM ppicl WHERE ppiclid=myppiclid;
  SELECT INTO myled led FROM ppicl WHERE ppiclid=myppiclid;    

  SELECT INTO modifiedKernel kernel FROM ppicl WHERE ppiclid=myppiclid;
  SELECT INTO modifiedKernelScript (SELECT mykernelscript || ' ' || condition );
   
  IF EXISTS (SELECT ppiclid FROM ppicl WHERE 
	kernel is not distinct from modifiedKernel 
	and corpus is not distinct from mycorpus 
	and parsertype is not distinct from myparsertype 
	and c is not distinct from myc 
	and j is not distinct from myj 
	and led is not distinct from myled
	and parser is not distinct from myparser 
	and kernel_script is not distinct from modifiedKernelScript) 
    THEN 
    RETURN (
    SELECT ppiclid FROM ppicl WHERE 
	kernel is not distinct from modifiedKernel 
	and corpus is not distinct from mycorpus 
	and parsertype is not distinct from myparsertype 
	and c is not distinct from myc 
	and j is not distinct from myj 
	and led is not distinct from myled
	and parser is not distinct from myparser 
	and kernel_script is not distinct from modifiedKernelScript); /* already exists */
  END IF;

  INSERT INTO ppicl (corpus,parsertype,parser,kernel, normalized,c,j,kernel_script) VALUES 
 	(mycorpus, myparsertype,myparser,modifiedKernel,'t',myc,myj,modifiedKernelScript);
	
  SELECT INTO newppiclid currval('ppiCL_ppiCLid_seq');

  INSERT INTO
    ppicloutput (expId, pair, output, prediction)
  SELECT
    newppiclid         as expId, 
    sub.pair	      as pair,
    (case when condition = 'DisableSentenceSeparator' then 
	(case 
		when sub.output = TRUE and sub.Twosentences = TRUE then FALSE 
		else sub.output 
	end)
	else 
	(case when condition = 'FirstEntityNNModifier(true)' then 
		(case 
			when sub.output = FALSE and sub.firstentityNNmodifier = TRUE then TRUE 
			else sub.output 
		end)
	else 
		(case when condition = 'FirstEntityNNModifier(false)' then 
		(case 
			when sub.output = TRUE and sub.firstentityNNmodifier = TRUE then FALSE 
			else sub.output 
		end)
	else
		(case when condition = 'SecondEntityNNModifier(true)' then 
		(case 
			when sub.output = FALSE and sub.secondentityNNmodifier = TRUE then TRUE 
			else sub.output 
		end)
	else 
		(case when condition = 'SecondEntityNNModifier(false)' then 
		(case 
			when sub.output = TRUE and sub.secondentityNNmodifier = TRUE then FALSE 
			else sub.output 
		end)
	else 
		(case when condition = 'BothEntityNNModifier(false)' then 
		(case 
			when sub.output = TRUE and sub.secondentityNNmodifier = TRUE and sub.firstentityNNmodifier = TRUE then FALSE 
			else sub.output 
		end)
	else 
		(case when condition = 'FirstEntityINGModifier(true)' then 
		(case 
			when sub.output = FALSE and sub.firstentityINGmodifier = TRUE then TRUE
			else sub.output 
		end)
	else 
		(case when condition = 'FirstEntityINGModifier(false)' then 
		(case 
			when sub.output = TRUE and sub.FirstEntityINGModifier = TRUE then FALSE 
			else sub.output
		end)
	else
		(case when condition = 'SecondEntityINGModifier(true)' then 
		(case 
			when sub.output = FALSE and sub.SecondEntityINGModifier = TRUE then TRUE
			else sub.output  
		end)
	else 
		(case when condition = 'SecondEntityINGModifier(false)' then 
		(case 
			when sub.output = TRUE and sub.SecondEntityINGModifier = TRUE then FALSE
			else sub.output 
		end)
	else 
		(case when condition = 'BothEntityINGModifier(false)' then 
		(case 
			when sub.output = TRUE and sub.SecondEntityINGModifier = TRUE and sub.FirstEntityINGModifier = TRUE then FALSE
			else sub.output 
		end)
	else 
		(case when condition = 'BothEntityNNINGModifier(false)' then 
		(case 
			when sub.output = TRUE and (
			(sub.SecondEntityINGModifier = TRUE and sub.FirstEntityINGModifier = TRUE) or
			(sub.SecondEntityNNModifier = TRUE and sub.FirstEntityNNModifier = TRUE) or 
			(sub.SecondEntityINGModifier = TRUE and sub.FirstEntityNNModifier = TRUE) or
			(sub.SecondEntityNNModifier = TRUE and sub.FirstEntityINGModifier = TRUE))
			then FALSE
			else sub.output 
		end)
	else 
		(case when condition = 'DisableEnumeration' then 
		(case 
			when sub.output = TRUE and sub.possibleenumeration = TRUE then FALSE
			else sub.output 
		end)
	end)
	end)
	end)	
	end)
	end)	
	end)
	end)
	end)	
	end)
	end)	
	end)
	end)	
    end) as output,
    (case when condition = 'DisableSentenceSeparator' then 
	(case 
		when sub.output = TRUE and sub.Twosentences = TRUE then -10 
		else sub.prediction 
	end)
	else 
		(case when condition = 'FirstEntityNNModifier(true)' then 
		(case 
			when sub.output = FALSE and sub.firstentityNNmodifier = TRUE then 10
			else sub.prediction 
		end)
	else 
		(case when condition = 'FirstEntityNNModifier(false)' then 
		(case 
			when sub.output = TRUE and sub.firstentityNNmodifier = TRUE then -10 
			else sub.prediction
		end)
	else
		(case when condition = 'SecondEntityNNModifier(true)' then 
		(case 
			when sub.output = FALSE and sub.secondentityNNmodifier = TRUE then 10
			else sub.prediction  
		end)
	else 
		(case when condition = 'SecondEntityNNModifier(false)' then 
		(case 
			when sub.output = TRUE and sub.secondentityNNmodifier = TRUE then -10
			else sub.prediction 
		end)
	else 
		(case when condition = 'BothEntityNNModifier(false)' then 
		(case 
			when sub.output = TRUE and sub.secondentityNNmodifier = TRUE and sub.firstentityNNmodifier = TRUE then -10
			else sub.prediction 
		end)
	else 
		(case when condition = 'FirstEntityINGModifier(true)' then 
		(case 
			when sub.output = FALSE and sub.firstentityINGmodifier = TRUE then 10
			else sub.prediction 
		end)
	else 
		(case when condition = 'FirstEntityINGModifier(false)' then 
		(case 
			when sub.output = TRUE and sub.FirstEntityINGModifier = TRUE then -10 
			else sub.prediction
		end)
	else
		(case when condition = 'SecondEntityINGModifier(true)' then 
		(case 
			when sub.output = FALSE and sub.SecondEntityINGModifier = TRUE then 10
			else sub.prediction  
		end)
	else 
		(case when condition = 'SecondEntityINGModifier(false)' then 
		(case 
			when sub.output = TRUE and sub.SecondEntityINGModifier = TRUE then -10
			else sub.prediction 
		end)
	else 
		(case when condition = 'BothEntityINGModifier(false)' then 
		(case 
			when sub.output = TRUE and sub.SecondEntityINGModifier = TRUE and sub.FirstEntityINGModifier = TRUE then -10
			else sub.prediction 
		end)
	else 
		(case when condition = 'BothEntityNNINGModifier(false)' then 
		(case 
			when sub.output = TRUE and (
			(sub.SecondEntityINGModifier = TRUE and sub.FirstEntityINGModifier = TRUE) or
			(sub.SecondEntityNNModifier = TRUE and sub.FirstEntityNNModifier = TRUE) or 
			(sub.SecondEntityINGModifier = TRUE and sub.FirstEntityNNModifier = TRUE) or
			(sub.SecondEntityNNModifier = TRUE and sub.FirstEntityINGModifier = TRUE))
			then -10
			else sub.prediction 
		end)
	else 
		(case when condition = 'DisableEnumeration' then 
		(case 
			when sub.output = TRUE and sub.possibleenumeration = TRUE then -10
			else sub.prediction
		end)
	end)
	end)
	end)	
	end)
	end)	
	end)
	end)
	end)	
	end)
	end)	
	end)
	end)	
    end) as prediction
  FROM
  (SELECT
     output,
     prediction,
     pair,
     TwoSentences,
     firstentityNNmodifier,
     secondentityNNmodifier,
     firstentityingmodifier,
     secondentityingmodifier,
     possibleenumeration
     FROM
    ppicloutput o
    join PairFeatures p on o.pair = p.pairLabel
    WHERE o.expid = myppiclid
   ) as sub
;

  UPDATE ppicl set 
	tp=s.tp,
	fp=s.fp, 
	fn=s.fn, 
	tn=s.tn,
	total=s.n,
	precision_=s.p,
	recall=s.r,
	f_measure=s.f,
	auc=newauc
  FROM cl_get_statistics(newppiclid) as s, compute_auc_cl(newppiclid) as newauc
  where ppiclid=newppiclid;

  RETURN newppiclid; /* just created */
  
END
$$
LANGUAGE 'plpgsql'
;
comment on function modify_experiment_cl(integer,Text) is 
'Creates a new CL experiment from $1 using the condition in $2';




