drop table if exists PairFeatures;

create table PairFeatures as 
select p.*,d.corpus,d.fold,d.doclabel,
(case when (sl.cloutput)=true then 1 else 0 end) as sl_cloutput,sl.clpred as sl_clpred,
(case when (sl.cvoutput)=true then 1 else 0 end) as sl_cvoutput,sl.cvpred as sl_cvpred,
(case when (st.cloutput)=true then 1 else 0 end) as st_cloutput,st.clpred as st_clpred,
(case when (st.cvoutput)=true then 1 else 0 end) as st_cvoutput,st.cvpred as st_cvpred,
(case when (sst.cloutput)=true then 1 else 0 end) as sst_cloutput,sst.clpred as sst_clpred,
(case when (sst.cvoutput)=true then 1 else 0 end) as sst_cvoutput,sst.cvpred as sst_cvpred,
(case when (pt.cloutput)=true then 1 else 0 end) as pt_cloutput,pt.clpred as pt_clpred,
(case when (pt.cvoutput)=true then 1 else 0 end) as pt_cvoutput,pt.cvpred as pt_cvpred,
(case when (spt.cloutput)=true then 1 else 0 end) as spt_cloutput,spt.clpred as spt_clpred,
(case when (spt.cvoutput)=true then 1 else 0 end) as spt_cvoutput,spt.cvpred as spt_cvpred,
(case when (kbsps.cloutput)=true then 1 else 0 end) as kbsps_cloutput,kbsps.clpred as kbsps_clpred,
(case when (kbsps.cvoutput)=true then 1 else 0 end) as kbsps_cvoutput,kbsps.cvpred as kbsps_cvpred,
(case when (cosine.cloutput)=true then 1 else 0 end) as cosine_cloutput,cosine.clpred as cosine_clpred,
(case when (cosine.cvoutput)=true then 1 else 0 end) as cosine_cvoutput,cosine.cvpred as cosine_cvpred,
(case when (edit.cloutput)=true then 1 else 0 end) as edit_cloutput,edit.clpred as edit_clpred,
(case when (edit.cvoutput)=true then 1 else 0 end) as edit_cvoutput,edit.cvpred as edit_cvpred,
(case when (apg.cloutput)=true then 1 else 0 end) as apg_cloutput,apg.clpred as apg_clpred,
(case when (apg.cvoutput)=true then 1 else 0 end) as apg_cvoutput,apg.cvpred as apg_cvpred,
(case when (shallow.cloutput)=true then 1 else 0 end) as shallow_cloutput,shallow.clpred as shallow_clpred,
(case when (shallow.cvoutput)=true then 1 else 0 end) as shallow_cvoutput,shallow.cvpred as shallow_cvpred,
(case when (lex.cloutput)=true then 1 else 0 end) as lex_cloutput,lex.clpred as lex_clpred,
(case when (lex.cvoutput)=true then 1 else 0 end) as lex_cvoutput,lex.cvpred as lex_cvpred,
(case when (syn.cloutput)=true then 1 else 0 end) as syn_cloutput,syn.clpred as syn_clpred,
(case when (syn.cvoutput)=true then 1 else 0 end) as syn_cvoutput,syn.cvpred as syn_cvpred,
(case when (comb.cloutput)=true then 1 else 0 end) as comb_cloutput,comb.clpred as comb_clpred,
(case when (comb.cvoutput)=true then 1 else 0 end) as comb_cvoutput,comb.cvpred as comb_cvpred,
word_length(blinded) as wcount,
char_length(blinded) as chcount,
(case when lower(p.entity1)=lower(p.entity2) then 1 else 0 end) as SameEntityName,
(case when be2>ee1 then word_length(between_entities(blinded,ee1,be2)) when be1>ee2 then word_length(between_entities(blinded,ee2,be1)) else 0 end) as entity_dist_word,
greatest(0,(-least(ee1,ee2)+greatest(be1,be2))) as entity_dist_char,
BeforeEntities(be1,ee1,be2,ee2,blinded),
BetweenEntities(be1,ee1,be2,ee2,blinded),
AfterEntities(be1,ee1,be2,ee2,blinded),
(case when (BetweenEntities(be1,ee1,be2,ee2,full_blinded_sentence(p.sentencelabel)) ~ '[.;][[:space:]]?[A-Z][a-z]|[.;][[:space:]]?[X]{2,}|[(]ii?i?v?[)]')=true then 1 else 0 end) as TwoSentences,
(case when (BetweenEntities(be1,ee1,be2,ee2,blinded) ~ '^[^()]*[)]|[(][^()]*$')=true then 1 else 0 end) as ParenthesisBetween,
(case when (lower(blinded) ~ 
$$\m(not?|neither|nor|without|but|den[yi][esding]*|never|unlike(ly)?)\M$$)=true then 1 else 0 end) as NegWordInSentence,
(case when (lower(BeforeEntities(be1,ee1,be2,ee2,blinded)) ~ 
$$\m(not?|neither|nor|without|but|den[yi][esding]*|never|unlike(ly)?)\M$$)=true then 1 else 0 end) as NegWordBefore,
(case when (lower(BetweenEntities(be1,ee1,be2,ee2,blinded)) ~ 
$$\m(not?|neither|nor|without|but|den[yi][esding]*|never|unlike(ly)?)\M$$)=true then 1 else 0 end) as NegWordBetween,
(case when (lower(AfterEntities(be1,ee1,be2,ee2,blinded)) ~ 
$$\m(not?|neither|nor|without|but|den[yi][esding]*|never|unlike(ly)?)\M$$)=true then 1 else 0 end) as NegWordAfter,
(case when (lower(blinded) ~ 
$$\m(may|might|would|could|likely|presum[a-z]+|probab[a-z]+|unknown|elucidat[esding]*|thought)\M$$)=true then 1 else 0 end) as HedgeWordInSentence,
(case when (lower(BeforeEntities(be1,ee1,be2,ee2,blinded)) ~ 
$$\m(may|might|would|could|likely|presum[a-z]+|probab[a-z]+|unknown|elucidat[esding]*|thought)\M$$)=true then 1 else 0 end) as HedgeWordBefore,
(case when (lower(BetweenEntities(be1,ee1,be2,ee2,blinded)) ~ 
$$\m(may|might|would|could|likely|presum[a-z]+|probab[a-z]+|unknown|elucidat[esding]*|thought)\M$$)=true then 1 else 0 end) as HedgeWordBetween,
(case when (lower(AfterEntities(be1,ee1,be2,ee2,blinded)) ~ 
$$\m(may|might|would|could|likely|presum[a-z]+|probab[a-z]+|unknown|elucidat[esding]*|thought)\M$$)=true then 1 else 0 end) as HedgeWordAfter,
(case when (lower(AfterEntities(be1,ee1,be2,ee2,blinded)) ~ 
'^[- ]?(receptor|inhibitor|kinase|ligand|promoter|ligase|mutant|repressor|reporter|receptor|region|coreceptor|factor|activator|homologue|segment|reductase)')=true then 1 else 0 end)
as SecondEntityNNModifier,
(case when (lower(BetweenEntities(be1,ee1,be2,ee2,blinded)) ~ 
'^[- ]?(receptor|inhibitor|kinase|ligand|promoter|ligase|mutant|repressor|reporter|receptor|region|coreceptor|factor|activator|homologue|segment|reductase)')=true then 1 else 0 end)
as FirstEntityNNModifier,
(case when (lower(AfterEntities(be1,ee1,be2,ee2,blinded)) ~ '^[- ]*(dependent|binding|signaling|activating|bundling|like)')=true then 1 else 0 end)
	as SecondEntityINGModifier,
(case when (lower(BetweenEntities(be1,ee1,be2,ee2,blinded)) ~ '^[- ]*(dependent|binding|signaling|activating|bundling|like)')=true then 1 else 0 end)
	as FirstEntityINGModifier,
(case when (exists(select 1 from iwords i where lower(blinded) ~ (' ' || i.word)))=true then 1 else 0 end) as iwordinsentence,
(case when (exists(select 1 from iwords i where lower(BeforeEntities(be1,ee1,be2,ee2,blinded)) ~ (' ' || i.word)))=true then 1 else 0 end) as iwordbefore,
(case when (exists(select 1 from iwords i where lower(BetweenEntities(be1,ee1,be2,ee2,blinded)) ~ (' ' || i.word)))=true then 1 else 0 end) as iwordbetween,
(case when (exists(select 1 from iwords i where lower(AfterEntities(be1,ee1,be2,ee2,blinded)) ~ (' ' || i.word)))=true then 1 else 0 end) as iwordafter,
(case when (BetweenEntities(be1,ee1,be2,ee2,blinded) ~ $$\mor\M$$)=true then 1 else 0 end) as OrBetweenEntities,
(case when (BetweenEntities(be1,ee1,be2,ee2,blinded) ~ $$\mand\M$$)=true then 1 else 0 end) as AndBetweenEntities,
(case when (BetweenEntities(be1,ee1,be2,ee2,blinded) ~ $$,[[:space:]]$$)=true then 1 else 0 end) as CommaSpaceBetweenEntities,
pp.depshortestpath as DepShortestPath,
pp.syntshortestpath as SyntShortestPath,
pp.dkl_synt_shortest_path as DKL_Synt_Shortest_Path,
pp.dkl_dep_shortest_path as DKL_Dep_Shortest_Path,
pp.border_subj as Border_subj,
pp.border_obj as Border_obj,
s.dkl_synt_tree as DKL_Synt_Tree,
s.dkl_dep_graph as DKL_Dep_Graph,
pps.protnumber as protnumber,
dtop.*,dtfp.*,dtos.*,dtfs.*
from PosNegNeutral p
left join dep_type_occurrence_pair dtop on dtop.dtop_pairlabel=p.pairlabel
left join dep_type_frequency_pair dtfp on dtfp.dtfp_pairlabel=p.pairlabel
left join dep_type_occurrence_sentence dtos on dtos.dtos_sentencelabel=p.sentencelabel
left join dep_type_frequency_sentence dtfs on dtfs.dtfs_sentencelabel=p.sentencelabel
join proteins_per_sentence pps on pps.sentenceLabel=p.sentenceLabel
join sentence s on s.label=p.sentencelabel
join doc d on s.doc = d.doclabel
join pair pp on pp.pairlabel=p.pairlabel 
join best_outputs('SL') sl on p.pairLabel=sl.pair
join best_outputs('ST') st on p.pairLabel=st.pair
join best_outputs('SST') sst on p.pairLabel=sst.pair
join best_outputs('PT') pt on p.pairLabel=pt.pair
join best_outputs('SpT') spt on p.pairLabel=spt.pair
join best_outputs('kBSPS') kbsps on p.pairLabel=kBSPS.pair
join best_outputs('cosine') cosine on p.pairLabel=cosine.pair
join best_outputs('edit') edit on p.pairLabel=edit.pair
join best_outputs('APG') apg on p.pairLabel=apg.pair
join best_outputs('Kim-shallow (thresholded)') shallow on p.pairLabel=shallow.pair
join best_outputs('Kim-lexical (thresholded)') lex on p.pairLabel=lex.pair
join best_outputs('Kim-syntactic (thresholded)') syn on p.pairLabel=syn.pair
join best_outputs('Kim-combined (thresholded)') comb on p.pairLabel=comb.pair
order by p.pairLabel
;

-- alter table PairFeatures add constraint PairFeatures_pkey primary key (pairLabel);
