DROP FUNCTION IF EXISTS repair_ppicv(INT);

CREATE FUNCTION repair_ppicv
(
  IN myppicvid INT
)
RETURNS INT AS
$$
BEGIN
  
  UPDATE ppicv set 
	tp=s.tp,
	fp=s.fp, 
	fn=s.fn, 
	tn=s.tn,
	total=s.n,
	precision_=s.p,
	recall=s.r,
	f_measure=s.f
  FROM get_statistics(myppicvid) as s
  where ppicvid=myppicvid;
  RETURN myppicvid; /* just repaired */
END
$$
LANGUAGE 'plpgsql'
;

DROP FUNCTION IF EXISTS repair_auc_ppicv(INT);
CREATE FUNCTION repair_auc_ppicv
(
  IN myppicvid INT
)
RETURNS INT AS
$$
BEGIN
  
  UPDATE ppicv set 
	aucs.tp,
	fp=s.fp, 
	fn=s.fn, 
	tn=s.tn,
	total=s.n,
	precision_=s.p,
	recall=s.r,
	f_measure=s.f
  FROM get_statistics(myppicvid) as s
  where ppicvid=myppicvid;
  RETURN myppicvid; /* just repaired */
END
$$
LANGUAGE 'plpgsql'
;

-- select repair_ppicv(t.ppicvid) from (select ppicvid from ppicv) as t;

-- select * from ppicv where kernel='APG' and c=0.25;

DROP FUNCTION IF EXISTS repair_ppicl(INT);

CREATE FUNCTION repair_ppicl
(
  IN myppiclid INT
)
RETURNS INT AS
$$
BEGIN
  
  UPDATE ppicl set 
	tp=s.tp,
	fp=s.fp, 
	fn=s.fn, 
	tn=s.tn,
	total=s.n,
	precision_=s.p,
	recall=s.r,
	f_measure=s.f
  FROM cl_get_statistics(myppiclid) as s
  where ppiclid=myppiclid;
  RETURN myppiclid; /* just repaired */
END
$$
LANGUAGE 'plpgsql'
;

-- select repair_ppicl(t.ppiclid) from (select ppiclid from ppicl where kernel='SL') as t;

DROP FUNCTION IF EXISTS repair_ppicc(INT);

CREATE FUNCTION repair_ppicc
(
  IN myppiccid INT
)
RETURNS INT AS
$$
BEGIN
  
  UPDATE ppicc set 
	tp=s.tp,
	fp=s.fp, 
	fn=s.fn, 
	tn=s.tn,
	total=s.n,
	precision_=s.p,
	recall=s.r,
	f_measure=s.f
  FROM cc_get_statistics(myppiccid) as s
  where ppiccid=myppiccid;
  RETURN myppiccid; /* just repaired */
END
$$
LANGUAGE 'plpgsql'
;

-- select repair_ppicc(t.ppiccid) from (select ppiccid from ppicc where kernel='SL') as t;

