drop view if exists sentence_stats;

create or replace view sentence_stats as 
select s.label,s.rawtext,
sum(case when p.groundTruth=false then 1 else 0 end) as gtf,
sum(case when p.groundTruth=true then 1 else 0 end) as gtt,
count(*) as cnt
 from sentence s
join pair p on substring(p.pairLabel from 1 for length(s.label))=s.label
group by s.label,s.rawtext
;

drop view if exists proteins_per_sentence;

create or replace view proteins_per_sentence as
select count(distinct e.entitylabel) as protnumber,sentencelabel
from PosNegNeutral p
join entity e on e.sentence=p.sentencelabel
group by sentenceLabel;


-- test 
-- select * from sentence_stats where label LIKE 'BioInfer.d263%';
