#install.packages("gplots")
library(gplots)

#setwd("/home/philippe/workspace/ppi-benchmark")


# fancy hclust plot
drawHeatmap  <- function(
	data,
    plotFile = "cvacc_clacc.pdf",
    margin=20) {

	pdf(plotFile)
	par(xpd=T, mar=par()$mar+c(0,0,0.1,0.1))
	heatmap( as.matrix(data),key=TRUE,densadj = 0.5,keysize = 1.5,trace="none", margin=c(margin, margin))
#	legend(x="topright",bty="n", cex=0.5)
	dev.off()
}


# read 
data <- read.csv("cvacc_clacc.csv", header=TRUE, as.is=TRUE)

cv <-  as.vector(sort(unique(data[,"cvacc"])))
cl <-  as.vector(sort(unique(data[,"clacc"])))

distances <- as.data.frame(matrix (data=0, nrow=length(cv), ncol=length(cl)))
colnames(distances) <- cl
rownames(distances) <- cv



for (i in 1:nrow(data)){
  distances[data[i,"cvacc"],data[i,"clacc"]] <- log1p(data[i,"num"])
#  distances[data[i,"clacc"],data[i,"cvacc"]] <- data[i,"num"]
}



pdf("cvacc_clacc.heatmap.pdf", width=5, height=5)
heatmap(as.matrix(distances), #RowSideColors=rpcol, ColSideColors=spcol,
#          distfun=function(data){dist(data, method = "euclidian")},
#          hclustfun=function(data){hclust(dist(data), method = "complete")},
          Rowv=NA, Colv=NA, 
		  col=cm.colors(1000),
          scale="none",
          legend=2,trace="none", density.info="none"#,density.info="none"
          )
#title(main="Distribution of CV and CL error levels", sub="ACC# = correctly classified by # kernels", 
#  	 xlab="CL", ylab="CV")
dev.off()

#pdf("cvacc_clacc.tree.pdf", width=4, height=5)
#plclust(hclust(as.dist(distances)),hmin=2000)
#dev.off()


# produce extra plot

drawHeatmap(distances,margin=15,plotFile="cvacc_clacc.heatmap.extra.pdf")

