#!/bin/sh

USER="$1"
#PSQL="psql -q -n -A -t"
SCHEMES="'public'"
set -ex
if [ -z "$1" ]; then
        echo "Something like: ./grant mydatabase myuser | psql mydatabase"
        exit
fi
DB=$1
if [ -z "$2" ]; then
        USER="$1"
fi
echo "-- Granting rights to $USER ($SCHEMES)"
# tables
Q="select 'grant all on '||schemaname||'.'||tablename||' to $USER;' from pg_tables where schemaname in ($SCHEMES);"
echo "$Q"

# views
Q="select 'grant all on '||schemaname||'.'||viewname||' to $USER;' from pg_views where schemaname in ($SCHEMES);"
echo "$Q"

# sequences
Q="select 'grant all on function '||n.nspname||'.'||p.proname||'('||oidvectortypes(p.proargtypes)||') to $USER;' from pg_proc p, pg_namespace n where n.oid = p.pronamespace and n.nspname in ($SCHEMES);"
echo "$Q"

# functions
Q="select 'grant all on '||n.nspname||'.'||c.relname||' to $USER;' from pg_class c, pg_namespace n where n.oid = c.relnamespace and c.relkind IN ('S') and n.nspname in ($SCHEMES);"
echo "$Q"

