--
-- tokens in sentence
--
DROP TABLE IF EXISTS sentenceToken CASCADE;
CREATE TABLE sentenceToken
(
  sentence      text    REFERENCES sentence,
  position      integer NOT NULL  CONSTRAINT nonnegative_position  CHECK (position >= 0), -- a sequence number within the sentence
  beginOffset   integer NOT NULL  CONSTRAINT nonnegative_beginOffset  CHECK (beginOffset >= 0),
  endOffset     integer NOT NULL  CONSTRAINT nonnegative_endOffset  CHECK (endOffset >= 0),
  tokenText     text    NOT NULL,
  lemma         text    NOT NULL,
  stem          text    NOT NULL,
  posTag        text    NOT NULL,
  
  CONSTRAINT unique_token_position  UNIQUE (sentence, position),
  CONSTRAINT unique_token_begin     UNIQUE (sentence, beginOffset),
  CONSTRAINT unique_token_end       UNIQUE (sentence, endOffset),
  CONSTRAINT less_begin_end         CHECK (beginOffset <= endOffset),
  CONSTRAINT primary_key primary key (sentence,position)
);


-- CREATE UNIQUE INDEX sentenceToken_offset_idx
--   ON sentenceToken (sentence, beginOffset);
