--
-- mapping
--
CREATE TABLE mapping
(
  mappingId    serial PRIMARY KEY,
  mappingName  text UNIQUE
);

--
-- map
--
CREATE TABLE entityMap
(
  mappingId   int     REFERENCES mapping,
  entity      text	  NOT NULL REFERENCES entity,
  mapped      integer
);

--
--  insert into entitymap select mappingId, entitylabel, cast(substring(origid for position('@' in origid)-1) as int) as origid from entity  join mapping on mappingname = 'UnambiguousGeneID' and entityLabel like 'PMC%' and entitylabel between 'PMB' AND 'PMD' and position('|' in origid) = 0;

CREATE UNIQUE INDEX entity_map_idx
  ON entityMap (mappingId, entity);


CREATE TABLE pairMap
(
  mappingId   int     NOT NULL REFERENCES mapping,
  pair        text	  NOT NULL REFERENCES pair,
  gene1       integer,
  gene2       integer
);

-- insert into pairmap select m.mappingId, pairlabel, em1.mapped, em2.mapped from pair p join mapping m on m.mappingname = 'UnambiguousGeneID' and pairLabel like 'PMC%' and pairlabel between 'PMB' AND 'PMD' join entitymap em1 on em1.entity = p.entity1 and em1.mappingid = m.mappingid join entitymap em2 on em2.entity = p.entity2 and em2.mappingid = m.mappingid;


CREATE UNIQUE INDEX pair_map_idx
  ON pairMap (mappingId, pair);
