#!/bin/bash

if [ $# -eq 0 ]; then
  echo 1>&2 Usage: $0 ppiSplitName ... 
  exit 127
fi

INTERACTION_ID=2
MAPPING_ID=1
OUTINTERACTION_ID=3
NAME=$1

DBNAME=ppi_reg
LOG=/dev/stderr
# INSERT INTO ppiSplit (name, corpus, parsertype, parser, kernel, kernel_script) VALUES 
#    ('piped9107','/tmp/PMC/test0.txt0000','POS tagger','?','SL','jsre; n=3 (n-gram), w=2 (        window)');
# INSERT INTO ppiSplitOutput (expId, pair, output, prediction) VALUES (currval('ppiSplit_ppiSplitid_seq'), 'PMC.dPMC3033918.s6.p0', '1', 0.477194654743);

OUTFILE=`echo "$NAME" | tr -sc 'a-zA-Z0-9' '_'`.tc.csv

#echo "SELECT mapped1, mapped2 FROM predictedInteractionMap('$NAME', $INTERACTION_ID, $MAPPING_ID);" \
echo "SELECT mapped1, mapped2, support FROM predictedInteractions('$NAME', $INTERACTION_ID, $MAPPING_ID);" \
    | tee "$LOG" \
    | psql -tA "$DBNAME" \
    | tee "$LOG" \
    | ./transitive-closure-undirected.pl \
    | tr '\t' '|' \
    | perl -ne "print \"$NAME (tc)|$OUTINTERACTION_ID|$MAPPING_ID|\$_\";" \
    | tee "$LOG" \
    > "$OUTFILE"
    
