-- no linebreaks
-- BEGIN

--\copy 
COPY
(SELECT
--
-- META INFORMATION
--
pairlabel,
fold,
(CASE WHEN gt = 'TRUE' then 1 else 0 end) as gt,
entity1,
entity2,
entitylabel1,
entitylabel2,
be1,
ee1,
be2,
ee2,
sentencelabel,
-- docLabel,
corpus,

--
-- CLASSIFICATION INFORMATION
--
hardness,
clacc,
cvacc,
sl_cloutput,
sl_clpred,
sl_cvoutput,
sl_cvpred,
st_cloutput,
st_clpred,
st_cvoutput,
st_cvpred,
sst_cloutput,
sst_clpred,
sst_cvoutput,
sst_cvpred,
pt_cloutput,
pt_clpred,
pt_cvoutput,
pt_cvpred,
spt_cloutput,
spt_clpred,
spt_cvoutput,
spt_cvpred,
kbsps_cloutput,
kbsps_clpred,
kbsps_cvoutput,
kbsps_cvpred,
cosine_cloutput,
cosine_clpred,
cosine_cvoutput,
cosine_cvpred,
edit_cloutput,
edit_clpred,
edit_cvoutput,
edit_cvpred,
apg_cloutput,
apg_clpred,
apg_cvoutput,
apg_cvpred,
shallow_cloutput,
shallow_clpred,
shallow_cvoutput,
shallow_cvpred,
lex_cloutput,
lex_clpred,
lex_cvoutput,
lex_cvpred,
syn_cloutput,
syn_clpred,
syn_cvoutput,
syn_cvpred,
comb_cloutput,
comb_clpred,
comb_cvoutput,
comb_cvpred,

--
-- FEATURES
--
wcount,
chcount,
entity_dist_word,
entity_dist_char,
-- beforeentities,
-- betweenentities,
-- afterentities,
twosentences,
parenthesisbetween,
negwordinsentence,
negwordbefore,
negwordbetween,
negwordafter,
hedgewordinsentence,
hedgewordbefore,
hedgewordbetween,
hedgewordafter,
secondentitynnmodifier,
firstentitynnmodifier,
secondentityingmodifier,
firstentityingmodifier,
iwordinsentence,
iwordbefore,
iwordbetween,
iwordafter,
orbetweenentities,
andbetweenentities,
commaspacebetweenentities,
depshortestpath,
syntshortestpath,
dkl_synt_shortest_path,
dkl_dep_shortest_path,
border_subj,
border_obj,
dkl_synt_tree,
dkl_dep_graph,
protnumber,

-- dtop_pairlabel,
dtop_conj,
dtop_csubjpass,
dtop_prepc_to,
dtop_prep_together_with,
dtop_prep_about,
dtop_prep_whereas,
dtop_prep_across,
dtop_prep_outside,
dtop_prep_over,
dtop_prep_vs_x46_,
dtop_iobj,
dtop_prep_through,
dtop_prepc_with,
dtop_xcomp,
dtop_csubj,
dtop_prep_between,
dtop_det,
dtop_predet,
dtop_prep_following,
dtop_advcl,
dtop_prt,
dtop_conj_only,
dtop_prep_before,
dtop_conj__x38_,
dtop_cop,
dtop_prep_transacting,
dtop_prepc_in,
dtop_prep_besides,
dtop_prep_along_with,
dtop_nsubj,
dtop_prepc_of,
dtop_prep_on,
dtop_prepc_via,
dtop_prep_until,
dtop_prep_as,
dtop_prep_because_of,
dtop_prepc_without,
dtop_prep_onto,
dtop_pcomp,
dtop_ccomp,
dtop_rcmod,
dtop_xsubj,
dtop_expl,
dtop_prep_including,
dtop_prep_despite,
dtop_conj_et,
dtop_rel,
dtop_prep_for,
dtop_prep_than,
dtop_conj_predominantly,
dtop_prep_like,
dtop_aux,
dtop_prepc_despite,
dtop_conj_or,
dtop_prep_to,
dtop_prep_within,
dtop_appos,
dtop_prep_in,
dtop_prep_among,
dtop_conj_nor,
dtop_prep_below,
dtop_prep_according_to,
dtop_prep_per,
dtop_prep_because,
dtop_prep_along,
dtop_prep_whereby,
dtop_prep_compared_to,
dtop_prep_under,
dtop_nsubjpass,
dtop_prep_unlike,
dtop_prep_whether,
dtop_prep_factor,
dtop_poss,
dtop_prep_around,
dtop_prep_against,
dtop_prep_beyond,
dtop_prep_without,
dtop_preconj,
dtop_prep_from,
dtop_prepc_on,
dtop_tmod,
dtop_prep_upon,
dtop_conj_negcc,
dtop_prep_considering,
dtop_conj_yet,
dtop_prep,
dtop_mark,
dtop_prepc_for,
dtop_prep_overexpressing,
dtop_neg,
dtop_prepc_around,
dtop_prep_compared_with,
dtop_auxpass,
dtop_quantmod,
dtop_prep_de,
dtop_conj_vs,
dtop_conj_but,
dtop_prepc_at,
dtop_prep_via,
dtop_conj_and_x47_or,
dtop_prepc_about,
dtop_pred,
dtop_prepc_by,
dtop_num,
dtop_number,
dtop_prep_since,
dtop_prep_towards,
dtop_attr,
dtop_prep_based_on,
dtop_conj_plus,
dtop_acomp,
dtop_partmod,
dtop_prep_above,
dtop_prep_inside,
dtop_complm,
dtop_prepc_from,
dtop_prep_at,
dtop_prep_throughout,
dtop_prep_toward,
dtop_prep_depending_on,
dtop_punct,
dtop_agent,
dtop_pobj,
dtop_amod,
dtop_prep_versus,
dtop_prep_with,
dtop_prep_of,
dtop_conj__x43_,
dtop_prep_that,
dtop_dobj,
dtop_prep_after,
dtop_prep_instead_of,
dtop_prepc_as,
dtop_purpcl,
dtop_prepc_under,
dtop_prep_into,
dtop_prep_during,
dtop_conj_and,
dtop_prep_near,
dtop_prepc_after,
dtop_conj_as,
dtop_conj__x43__x47__x45_,
dtop_prepc_between,
dtop_prep_behind,
dtop_prep_by,
dtop_conj_versus,
dtop_prep_na,
dtop_dep,
dtop_nn,
dtop_prep_icv,
dtop_conj_vs_x46_,
dtop_infmod,
dtop_conj_x,
dtop_advmod,
dtop_prepc_whether,
dtop_prep_due_to,
dtop_measure,

-- dtfp_pairlabel,
dtfp_conj,
dtfp_csubjpass,
dtfp_prepc_to,
dtfp_prep_together_with,
dtfp_prep_about,
dtfp_prep_whereas,
dtfp_prep_across,
dtfp_prep_outside,
dtfp_prep_over,
dtfp_prep_vs_x46_,
dtfp_iobj,
dtfp_prep_through,
dtfp_prepc_with,
dtfp_xcomp,
dtfp_csubj,
dtfp_prep_between,
dtfp_det,
dtfp_predet,
dtfp_prep_following,
dtfp_advcl,
dtfp_prt,
dtfp_conj_only,
dtfp_prep_before,
dtfp_conj__x38_,
dtfp_cop,
dtfp_prep_transacting,
dtfp_prepc_in,
dtfp_prep_besides,
dtfp_prep_along_with,
dtfp_nsubj,
dtfp_prepc_of,
dtfp_prep_on,
dtfp_prepc_via,
dtfp_prep_until,
dtfp_prep_as,
dtfp_prep_because_of,
dtfp_prepc_without,
dtfp_prep_onto,
dtfp_pcomp,
dtfp_ccomp,
dtfp_rcmod,
dtfp_xsubj,
dtfp_expl,
dtfp_prep_including,
dtfp_prep_despite,
dtfp_conj_et,
dtfp_rel,
dtfp_prep_for,
dtfp_prep_than,
dtfp_conj_predominantly,
dtfp_prep_like,
dtfp_aux,
dtfp_prepc_despite,
dtfp_conj_or,
dtfp_prep_to,
dtfp_prep_within,
dtfp_appos,
dtfp_prep_in,
dtfp_prep_among,
dtfp_conj_nor,
dtfp_prep_below,
dtfp_prep_according_to,
dtfp_prep_per,
dtfp_prep_because,
dtfp_prep_along,
dtfp_prep_whereby,
dtfp_prep_compared_to,
dtfp_prep_under,
dtfp_nsubjpass,
dtfp_prep_unlike,
dtfp_prep_whether,
dtfp_prep_factor,
dtfp_poss,
dtfp_prep_around,
dtfp_prep_against,
dtfp_prep_beyond,
dtfp_prep_without,
dtfp_preconj,
dtfp_prep_from,
dtfp_prepc_on,
dtfp_tmod,
dtfp_prep_upon,
dtfp_conj_negcc,
dtfp_prep_considering,
dtfp_conj_yet,
dtfp_prep,
dtfp_mark,
dtfp_prepc_for,
dtfp_prep_overexpressing,
dtfp_neg,
dtfp_prepc_around,
dtfp_prep_compared_with,
dtfp_auxpass,
dtfp_quantmod,
dtfp_prep_de,
dtfp_conj_vs,
dtfp_conj_but,
dtfp_prepc_at,
dtfp_prep_via,
dtfp_conj_and_x47_or,
dtfp_prepc_about,
dtfp_pred,
dtfp_prepc_by,
dtfp_num,
dtfp_number,
dtfp_prep_since,
dtfp_prep_towards,
dtfp_attr,
dtfp_prep_based_on,
dtfp_conj_plus,
dtfp_acomp,
dtfp_partmod,
dtfp_prep_above,
dtfp_prep_inside,
dtfp_complm,
dtfp_prepc_from,
dtfp_prep_at,
dtfp_prep_throughout,
dtfp_prep_toward,
dtfp_prep_depending_on,
dtfp_punct,
dtfp_agent,
dtfp_pobj,
dtfp_amod,
dtfp_prep_versus,
dtfp_prep_with,
dtfp_prep_of,
dtfp_conj__x43_,
dtfp_prep_that,
dtfp_dobj,
dtfp_prep_after,
dtfp_prep_instead_of,
dtfp_prepc_as,
dtfp_purpcl,
dtfp_prepc_under,
dtfp_prep_into,
dtfp_prep_during,
dtfp_conj_and,
dtfp_prep_near,
dtfp_prepc_after,
dtfp_conj_as,
dtfp_conj__x43__x47__x45_,
dtfp_prepc_between,
dtfp_prep_behind,
dtfp_prep_by,
dtfp_conj_versus,
dtfp_prep_na,
dtfp_dep,
dtfp_nn,
dtfp_prep_icv,
dtfp_conj_vs_x46_,
dtfp_infmod,
dtfp_conj_x,
dtfp_advmod,
dtfp_prepc_whether,
dtfp_prep_due_to,
dtfp_measure,

-- dtos_sentencelabel,
dtos_conj,
dtos_csubjpass,
dtos_prepc_to,
dtos_prep_together_with,
dtos_prep_about,
dtos_prep_whereas,
dtos_prep_across,
dtos_prep_outside,
dtos_prep_over,
dtos_prep_vs_x46_,
dtos_iobj,
dtos_prep_through,
dtos_prepc_with,
dtos_xcomp,
dtos_csubj,
dtos_prep_between,
dtos_det,
dtos_predet,
dtos_prep_following,
dtos_advcl,
dtos_prt,
dtos_conj_only,
dtos_prep_before,
dtos_conj__x38_,
dtos_cop,
dtos_prep_transacting,
dtos_prepc_in,
dtos_prep_besides,
dtos_prep_along_with,
dtos_nsubj,
dtos_prepc_of,
dtos_prep_on,
dtos_prepc_via,
dtos_prep_until,
dtos_prep_as,
dtos_prep_because_of,
dtos_prepc_without,
dtos_prep_onto,
dtos_pcomp,
dtos_ccomp,
dtos_rcmod,
dtos_xsubj,
dtos_expl,
dtos_prep_including,
dtos_prep_despite,
dtos_conj_et,
dtos_rel,
dtos_prep_for,
dtos_prep_than,
dtos_conj_predominantly,
dtos_prep_like,
dtos_aux,
dtos_prepc_despite,
dtos_conj_or,
dtos_prep_to,
dtos_prep_within,
dtos_appos,
dtos_prep_in,
dtos_prep_among,
dtos_conj_nor,
dtos_prep_below,
dtos_prep_according_to,
dtos_prep_per,
dtos_prep_because,
dtos_prep_along,
dtos_prep_whereby,
dtos_prep_compared_to,
dtos_prep_under,
dtos_nsubjpass,
dtos_prep_unlike,
dtos_prep_whether,
dtos_prep_factor,
dtos_poss,
dtos_prep_around,
dtos_prep_against,
dtos_prep_beyond,
dtos_prep_without,
dtos_preconj,
dtos_prep_from,
dtos_prepc_on,
dtos_tmod,
dtos_prep_upon,
dtos_conj_negcc,
dtos_prep_considering,
dtos_conj_yet,
dtos_prep,
dtos_mark,
dtos_prepc_for,
dtos_prep_overexpressing,
dtos_neg,
dtos_prepc_around,
dtos_prep_compared_with,
dtos_auxpass,
dtos_quantmod,
dtos_prep_de,
dtos_conj_vs,
dtos_conj_but,
dtos_prepc_at,
dtos_prep_via,
dtos_conj_and_x47_or,
dtos_prepc_about,
dtos_pred,
dtos_prepc_by,
dtos_num,
dtos_number,
dtos_prep_since,
dtos_prep_towards,
dtos_attr,
dtos_prep_based_on,
dtos_conj_plus,
dtos_acomp,
dtos_partmod,
dtos_prep_above,
dtos_prep_inside,
dtos_complm,
dtos_prepc_from,
dtos_prep_at,
dtos_prep_throughout,
dtos_prep_toward,
dtos_prep_depending_on,
dtos_punct,
dtos_agent,
dtos_pobj,
dtos_amod,
dtos_prep_versus,
dtos_prep_with,
dtos_prep_of,
dtos_conj__x43_,
dtos_prep_that,
dtos_dobj,
dtos_prep_after,
dtos_prep_instead_of,
dtos_prepc_as,
dtos_purpcl,
dtos_prepc_under,
dtos_prep_into,
dtos_prep_during,
dtos_conj_and,
dtos_prep_near,
dtos_prepc_after,
dtos_conj_as,
dtos_conj__x43__x47__x45_,
dtos_prepc_between,
dtos_prep_behind,
dtos_prep_by,
dtos_conj_versus,
dtos_prep_na,
dtos_dep,
dtos_nn,
dtos_prep_icv,
dtos_conj_vs_x46_,
dtos_infmod,
dtos_conj_x,
dtos_advmod,
dtos_prepc_whether,
dtos_prep_due_to,
dtos_measure,

-- dtfs_sentencelabel,
dtfs_conj,
dtfs_csubjpass,
dtfs_prepc_to,
dtfs_prep_together_with,
dtfs_prep_about,
dtfs_prep_whereas,
dtfs_prep_across,
dtfs_prep_outside,
dtfs_prep_over,
dtfs_prep_vs_x46_,
dtfs_iobj,
dtfs_prep_through,
dtfs_prepc_with,
dtfs_xcomp,
dtfs_csubj,
dtfs_prep_between,
dtfs_det,
dtfs_predet,
dtfs_prep_following,
dtfs_advcl,
dtfs_prt,
dtfs_conj_only,
dtfs_prep_before,
dtfs_conj__x38_,
dtfs_cop,
dtfs_prep_transacting,
dtfs_prepc_in,
dtfs_prep_besides,
dtfs_prep_along_with,
dtfs_nsubj,
dtfs_prepc_of,
dtfs_prep_on,
dtfs_prepc_via,
dtfs_prep_until,
dtfs_prep_as,
dtfs_prep_because_of,
dtfs_prepc_without,
dtfs_prep_onto,
dtfs_pcomp,
dtfs_ccomp,
dtfs_rcmod,
dtfs_xsubj,
dtfs_expl,
dtfs_prep_including,
dtfs_prep_despite,
dtfs_conj_et,
dtfs_rel,
dtfs_prep_for,
dtfs_prep_than,
dtfs_conj_predominantly,
dtfs_prep_like,
dtfs_aux,
dtfs_prepc_despite,
dtfs_conj_or,
dtfs_prep_to,
dtfs_prep_within,
dtfs_appos,
dtfs_prep_in,
dtfs_prep_among,
dtfs_conj_nor,
dtfs_prep_below,
dtfs_prep_according_to,
dtfs_prep_per,
dtfs_prep_because,
dtfs_prep_along,
dtfs_prep_whereby,
dtfs_prep_compared_to,
dtfs_prep_under,
dtfs_nsubjpass,
dtfs_prep_unlike,
dtfs_prep_whether,
dtfs_prep_factor,
dtfs_poss,
dtfs_prep_around,
dtfs_prep_against,
dtfs_prep_beyond,
dtfs_prep_without,
dtfs_preconj,
dtfs_prep_from,
dtfs_prepc_on,
dtfs_tmod,
dtfs_prep_upon,
dtfs_conj_negcc,
dtfs_prep_considering,
dtfs_conj_yet,
dtfs_prep,
dtfs_mark,
dtfs_prepc_for,
dtfs_prep_overexpressing,
dtfs_neg,
dtfs_prepc_around,
dtfs_prep_compared_with,
dtfs_auxpass,
dtfs_quantmod,
dtfs_prep_de,
dtfs_conj_vs,
dtfs_conj_but,
dtfs_prepc_at,
dtfs_prep_via,
dtfs_conj_and_x47_or,
dtfs_prepc_about,
dtfs_pred,
dtfs_prepc_by,
dtfs_num,
dtfs_number,
dtfs_prep_since,
dtfs_prep_towards,
dtfs_attr,
dtfs_prep_based_on,
dtfs_conj_plus,
dtfs_acomp,
dtfs_partmod,
dtfs_prep_above,
dtfs_prep_inside,
dtfs_complm,
dtfs_prepc_from,
dtfs_prep_at,
dtfs_prep_throughout,
dtfs_prep_toward,
dtfs_prep_depending_on,
dtfs_punct,
dtfs_agent,
dtfs_pobj,
dtfs_amod,
dtfs_prep_versus,
dtfs_prep_with,
dtfs_prep_of,
dtfs_conj__x43_,
dtfs_prep_that,
dtfs_dobj,
dtfs_prep_after,
dtfs_prep_instead_of,
dtfs_prepc_as,
dtfs_purpcl,
dtfs_prepc_under,
dtfs_prep_into,
dtfs_prep_during,
dtfs_conj_and,
dtfs_prep_near,
dtfs_prepc_after,
dtfs_conj_as,
dtfs_conj__x43__x47__x45_,
dtfs_prepc_between,
dtfs_prep_behind,
dtfs_prep_by,
dtfs_conj_versus,
dtfs_prep_na,
dtfs_dep,
dtfs_nn,
dtfs_prep_icv,
dtfs_conj_vs_x46_,
dtfs_infmod,
dtfs_conj_x,
dtfs_advmod,
dtfs_prepc_whether,
dtfs_prep_due_to,
dtfs_measure
---------------------
FROM pairFeatures_distinct
ORDER BY RANDOM()
--LIMIT 200
)

TO STDOUT
-- 'pairfeatures.csv' 
WITH CSV HEADER 
	DELIMITER ','
	QUOTE '"'
	FORCE QUOTE 
		pairLabel, sentenceLabel,
		corpus,
		--docLabel,
		entity1, entity2, 
		entitylabel1, entitylabel2, 
		hardness


-- END
-- / no linebreaks
