#!/usr/bin/perl -w
#
# remove linebreaks between markers to make \copy happy
#
# written by Andreas 'ads' Scherbaum
#
# description:
#    remove linebreaks between start and stop markers
#    the markers are:
#      -- no linebreaks
#      -- / no linebreaks
#
#
# history:   v1.0  2008-10-08
#                  initial version
 
use strict;
use warnings;

# loop through stdin
while (<>) {
    # use the flip-flop operator to search for marker
    if (/\-\- no linebreaks/ .. /\-\- \/ no linebreaks/) {
	s/^\s+//;
	s/^--.*$//;
	s/\s+$//s;
	
#        if (substr($_, 0, 2) eq '--') {
#            # remove SQL coments
#            $_ = '';
 #       } else {
#            # remove linebreaks
#            $_ =~ s/[\r\n]//gs;
#        }
    }
    print "$_ " if $_ ne '';
}
