

-- -- All experiments (view + select)
-- create or replace view evaluatedcvexperiments as 
-- SELECT ppicvid as expid from ppiCV;
-- 
-- select p.pairLabel, pc.kernel,count(*),p.groundTruth, a.output, min(a.prediction),max(a.prediction),pc.led,pc.lmin,pc.lmax,pc.j,pc.c,pc.kernel_script
-- -- 	newStats(
-- -- 	sum(case when a.output=TRUE and p.GroundTruth = a.output then 1 else 0 end),
-- -- 	sum(case when a.output=TRUE and p.GroundTruth != a.output then 1 else 0 end),
-- -- 	sum(case when a.output=FALSE and p.GroundTruth != a.output then 1 else 0 end),
-- -- 	sum(case when a.output=FALSE and p.GroundTruth = a.output then 1 else 0 end)
-- -- 	)
-- from ppiCVoutput a
-- inner join evaluatedcvexperiments e on e.expiD=a.expID
-- inner join pair p on p.pairLabel = a.pair
-- inner join ppicv pc on pc.ppicvid = a.expId
-- where p.pairLabel = 'HPRD50.d36.s4.p1'
-- group by p.pairLabel, p.GroundTruth, pc.kernel, a.output,pc.led,pc.lmin,pc.lmax,pc.j,pc.c,pc.kernel_script
-- order by pc.kernel, a.output
-- ;
-- 

DROP TYPE IF EXISTS EA CASCADE;
CREATE TYPE EA AS 
(
    pairLabel TEXT,
    kernel TEXT,
    GT TEXT,
    output TEXT,
    prediction DOUBLE PRECISION,
    led TEXT,
    lmin INTEGER,
    lmax INTEGER,
    j DOUBLE PRECISION,
    c DOUBLE PRECISION,
    kernel_script TEXT
);

drop function if exists single_pair_EA(Text);
create or replace function single_pair_EA(pairLabel Text) returns setof EA as 
$$
select * from
(select p.pairLabel, pc.kernel,case when p.groundTruth='TRUE' then 'TRUE' else 'FALSE' end as GT,
case when a.output='TRUE' then 'TRUE' else 'FALSE' end as output,a.prediction,
pc.led,pc.lmin,pc.lmax,pc.j,pc.c,pc.kernel_script
from ppiCVoutput a
inner join evaluatedcvexperiments e on e.expiD=a.expID
inner join pair p on p.pairLabel = a.pair
inner join ppicv pc on pc.ppicvid = a.expId
where p.pairLabel = $1
and (pc.kernel='SL'
or (pc.kernel = 'ST' and pc.j=2 and pc.c=1)
or (pc.kernel = 'SST' and pc.j=2 and pc.c=1)
or (pc.kernel = 'PT' and pc.j=2 and pc.c=512)
or (pc.kernel = 'SpT' and pc.j=3 and pc.c=0.0625 and pc.kernel_script='u-spectrum(2)')
or (pc.kernel = 'kBSPS' and pc.j=3 and pc.lmin = 1 and pc.lmax = 3 and pc.led = 'L=0,E=0,D=0,l=3,e=3,d=6')
or (pc.kernel = 'cosine' and pc.c=10)
or (pc.kernel = 'edit' and pc.c=10)
or (pc.kernel = 'APG' and pc.c=0.25))
group by p.pairLabel, p.GroundTruth, pc.kernel, a.output,pc.led,pc.lmin,pc.lmax,pc.j,pc.c,pc.kernel_script,a.prediction
union all
select p.pairLabel, pc.kernel,case when p.groundTruth='TRUE' then 'TRUE' else 'FALSE' end as GT,
 case when (a.prediction>tt.th) then 'TRUE' else 'FALSE' end as output,a.prediction,
pc.led,pc.lmin,pc.lmax,pc.j,pc.c,pc.kernel_script
from thresholds tt, ppiCVoutput a
inner join ppicv pc on pc.ppicvid = a.expId
inner join pair p on p.pairLabel = a.pair
where p.pairLabel = $1
and 
((pc.kernel = 'Kim' and pc.c=0.25 and pc.kernel_script='combined -w0 1 -w1 2 -nu 0.5' and tt.th=0.3)
or (pc.kernel = 'Kim' and pc.c=0.25 and pc.kernel_script='syntactic -w0 1 -w1 2 -nu 0.5' and tt.th=0.25)
or (pc.kernel = 'Kim' and pc.c=0.125 and pc.kernel_script='shallow -w0 1 -w1 4 -nu 0.5' and tt.th=0.25)
or (pc.kernel = 'Kim' and pc.c=1 and pc.kernel_script='lexical -w0 1 -w1 4 -nu 0.5' and tt.th=0.2)
)
group by p.pairLabel, p.GroundTruth, pc.kernel, a.output,pc.led,pc.lmin,pc.lmax,pc.j,pc.c,pc.kernel_script,a.prediction,tt.th
) as t1
order by t1.kernel
;
$$
language SQL stable returns null on null input;

-- test
-- select * from single_pair_EA('HPRD50.d26.s7.p3');

