-- create or replace view token_verb_support as 
-- select count(*) as cnt,lemma from sentencetoken st
-- where postag like 'VB%'
-- group by lemma
-- ;

-- create or replace view token_verb_freq as
-- select *,cnt/(select sum(t.cnt) from token_verb_support as t) as ratio from token_verb_support order by ratio desc;
-- 

-- create or replace view verb_diff_gt as 
-- select hardness,gt,p.sentencelabel,(count(*)+0.0)/(tt.totalsentence+0.0) as ratio from posnegneutral p
-- join (select count(*) as totalsentence,sentencelabel from posnegneutral as t group by t.sentencelabel) tt 
-- on tt.sentencelabel=p.sentencelabel
-- group by hardness,gt,p.sentencelabel,tt.totalsentence
-- order by p.sentencelabel;
-- 

drop type if exists lemmasupport cascade;

create type lemmasupport as (
	lemma text,
	support numeric
);

drop function if exists lemma_verb_support_byhardnessgt(text,text);

create or replace function lemma_verb_support_byhardnessgt(hardness text, GT text) returns setof lemmasupport
as
$$
select lemma,sum(ratio) as support
from verb_diff_gt v
join sentencetoken st on st.sentence=v.sentencelabel
where hardness = $1 and gt=$2
group by lemma
$$
language SQL stable returns null on null input
;

drop type if exists lemmafreq cascade;

create type lemmafreq as (
	lemma text,
	support numeric,
	freq numeric
);

drop function if exists lemma_verb_freq_byhardnessgt(text,text);

create or replace function lemma_verb_freq_byhardnessgt(hardness text, GT text) returns setof lemmafreq
as 
$$
select lemma,support,support/(select sum(t.support) from lemma_verb_support_byhardnessgt($1,$2) as t) as freq
from lemma_verb_support_byhardnessgt($1,$2)
$$
language SQL stable returns null on null input
;


select a.*,coalesce(rr(b.support),0) as DNEGT_support,coalesce(b.freq,0.0) as DNEGT_freq,a.ratio-coalesce(b.freq,0.0) as diff
from lemma_verb_freq a
left join lemma_verb_freq_byhardnessgt('D','FALSE') b on a.lemma=b.lemma
order by diff desc
;
-- -- 
-- 
-- select * from 
-- (
-- select count(*),lemma from sentencetoken st
-- join pos_diffic pd on st.sentence = pd.sentencelabel
-- where postag like 'VB%' -- and lemma like 'activ%'
-- --and hardness = 'D' and GT='TRUE'
-- group by lemma) as t
-- order by count(*) desc
-- ;