#!/bin/bash

set -ex

# import kernel-independent parameters

. ../config.sh

# import kernel-dependent parameters

. config.sh

# kernels='syn lex pos comp'

for corpus in ${allCorpora};
do
	for kernel in ${kernels};
	do
		inDir=${corpusDir}/libSVM-learning-format/${expType}/${kernel}/${corpus}
		for c in ${cs};
		do
			for j in ${js};
			do	
				for w in ${ws}
				do
					options="-c ${c} -j ${j} -o '-w0 1 -w1 ${w}'"
					commands+="java ${MEM} -cp '${FayruzovCP}' client.Runners -n ${expType}${corpus}${kernel} -l ${expType}${corpus}${kernel} ${FayruzovAllDirs} -m ${MODE} -t -p ${propsDir}/${expType}${corpus}${kernel}.props ${options}"
					commands+="#"
				done
			done
		done
	done
done

echo ${commands} | nice nice xargs -d '#' --no-run-if-empty -P ${numberofcores} --max-args 1 -t bash -c

echo "finished"
