#!/usr/bin/python
#nice python run.py 1>run.out 2>run.err
import os
import glob
import subprocess
import re
import time
import math
import sys
import locale
locale.setlocale(locale.LC_ALL, '')

sys.path.append('..')
from jsreconfig import *
from addids import *
from convert import *
from distributed import *
from PerformanceMeasures import computeAUC
from Fscore import *

def readAUC(source):
    predictions = []
    correct = []
    for line in source:
        line = line.strip().split()
        predictions.append(float(line[2]))
        correct.append(float(line[1]))
    auc = computeAUC(predictions, correct)
    return auc

base  = basepath +os.sep +'CC' +os.sep
splits  = 'corpus'
trained = 'trained'
predict = 'predict'

#corpora= os.listdir(base+splits) #Contains all five corpora
corpora = os.environ["CORPORA"].split()
#Train a Model

print "Step1-Training"
cmd =[]
regex = re.compile('\D+\d+')
for corpus in corpora:
    print corpus
    train = base +splits +os.sep +corpus +os.sep +"corpus.txt"
    model = base +splits +os.sep +corpus +os.sep +"train.model"
    cmd.append("java -classpath '" +jsre_classpath  +"' -mx2048M org.itc.irst.tcc.sre.Train -m 2048 -k SL" +" " +train +" " +model)


os.chdir(jsre)
runDistributed(5, cmd)  


print "Step 2 predict!"
cmd= []
for corpus in corpora:
    print corpus

    model = base +splits +os.sep +corpus +os.sep +"train.model"      
    for predict in corpora: #Iterate over the corpora
        if predict != corpus: #Predict only those where model is not trained on 
            test = base +splits +os.sep +predict +os.sep +"corpus.txt"
            outfile= base +splits +os.sep +corpus +os.sep +predict +".predict"
            cmd.append("java -classpath '" +jsre_classpath +"' -mx2048M org.itc.irst.tcc.sre.Predict " +test   +" "  +model +" " + outfile )  

os.chdir(jsre)
runDistributed(5, cmd) 


print "Step 3 evaluate!"
threshold = 0.
for corpus in corpora:
    print corpus    
    for predict in corpora:
        if predict != corpus:
            print(base+os.sep+corpus+"-"+predict+".output.sql")
            resultFile = open(base+os.sep+corpus+"-"+predict+".output.sql",'w')
            
            prediction= base +splits +os.sep +corpus +os.sep +predict +".predict"
            print("Parsing: " +prediction)
            
            convert(prediction)
            f= open(prediction)
            auc= readAUC(f)
            f.close()
            f= open(prediction)
            F, prec, rec = readResults(f,threshold)
            f.close()
            print( "Results:", auc, F, prec, rec)

            test = base +splits +os.sep +predict +os.sep +"corpus.txt"            
            addids(prediction, test) # Replace sequence number with original pair IDs from

            resultFile.write("INSERT INTO ppiCC (corpus, test, parsertype, parser, kernel, kernel_script) VALUES" +"('" +corpus +"','" +predict +"','POS tagger','"  +"TextPRO (Version06?)" +"','SL'," "'jsre; n=3 (n-gram), w=2 (window)');\n")

            #Comment: Line added by philippe to have this information in the database too
            resultFile.write("UPDATE ppiCC SET auc =  %.4f, precision_ =  %.4f, recall =  %.4f, f_measure = %.4f WHERE ppiCCid = currval('ppiCC_ppiCCid_seq');\n" % (auc, prec, rec, F) )
            
            f1= open(prediction)
            for line in f1:
                line = line.split()
                resultFile.write("INSERT INTO ppiCCoutput (expId, pair, output, prediction) VALUES (currval('ppiCC_ppiCCid_seq'), '" + line[0] + "', '" + ('1' if float(line[2]) >= threshold else '0') + "', " + line[2] +");\n")
            f1.close()             
            resultFile.close()


