#!/usr/bin/python
#nice python run.py 1>run.out 2>run.err
import os
import glob
import subprocess
import re
import time
import math
import sys
import shutil
import locale
locale.setlocale(locale.LC_ALL, '')

sys.path.append('..')
from jsreconfig import *
from addids import *
from convert import *
from distributed import *
from PerformanceMeasures import computeAUC
from Fscore import *

def readAUC(source):
    predictions = []
    correct = []
    for line in source:
        line = line.strip().split()
        predictions.append(float(line[2]))
        correct.append(float(line[1]))
    auc = computeAUC(predictions, correct)
    return auc



base  = basepath +os.sep +'CL' +os.sep
splits  = 'corpus'
trained = 'trained'
predict = 'predict'
result  = base + 'output.sql'

#corpora= os.listdir(base+splits) #Contains all five corpora
corpora = os.environ["CORPORA"].split()

#Train a Model
print "Step1-Training"
cmd =[]
regex = re.compile('\D+\d+')
for corpus in corpora:
    print corpus
    train = base +splits +os.sep +corpus +os.sep +"train.txt"
    destination = open(train, 'wb')
    for train_corpus in corpora:
        if train_corpus == corpus:
            continue
        train_file = base +splits +os.sep +train_corpus +os.sep +"corpus.txt"
        shutil.copyfileobj(open(train_file, 'rb'), destination)
    destination.close()

    model = base +splits +os.sep +corpus +os.sep +"train.model"

    cmd.append("java -classpath '" +jsre_classpath  +"' -mx2048M org.itc.irst.tcc.sre.Train -m 2048 -k SL" +" " +train +" " +model)

os.chdir(jsre)
runDistributed(5, cmd)  

print "Step 2 predict!"
cmd= []
for corpus in corpora:
    print corpus
    outfile= (base +splits +os.sep +corpus +os.sep +"test.predict")
    test = (base +splits +os.sep +corpus +os.sep +"corpus.txt")
    for model in glob.glob(base +splits +os.sep +corpus +os.sep +"train.model"):
        print model
        cmd.append("java -classpath '" +jsre_classpath +"' -mx2048M org.itc.irst.tcc.sre.Predict " +test   +" "  +model +" " + outfile )

os.chdir(jsre)
runDistributed(5, cmd)


#print "Step 3 evaluate!"
threshold = 0
resultFile = open(result,'w')
for corpus in corpora:
    print corpus
    prediction= (base +splits +os.sep +corpus +os.sep +"test.predict")
    convert(prediction)

    f= open(prediction)
    auc= readAUC(f)
    f.close()
    f= open(prediction)
    F, prec, rec = readResults(f,0)
    f.close()
    print auc, F, prec, rec

    test = (base +splits +os.sep +corpus +os.sep +"corpus.txt")
    addids(prediction, test) # Replace sequence number with original pair IDs from

    resultFile.write("INSERT INTO ppiCL (corpus, parsertype, parser, kernel, kernel_script) VALUES" +"('" +corpus +"','POS tagger','"  +"TextPRO (Version06?)" +"','SL'," "'jsre; n=3 (n-gram), w=2 (window)');\n")
    f1= open(prediction)
    for line in f1:
        line = line.split()
        resultFile.write("INSERT INTO ppiCLoutput (expId, pair, output, prediction) VALUES (currval('ppiCL_ppiCLid_seq'), '" + line[0] + "', '" + ('1' if float(line[2]) >= threshold else '0') + "', " + line[2] +");\n")
    f1.close()  


resultFile.close


