#!/bin/bash

set -ex

# import kernel-independent parameters

. ../config.sh 

# import kernel-dependent parameters

. config.sh

for corpus in ${allCorpora};
do
	# when CC then "location" is empty, otherwise, see below
	if [ ${expType} != "CC" ];
	then
		location=$corpus-folds 
	fi
	inDir=${corpusDir}/learning-format/${expType}/MOSCHITTI/${location}
	for kernel in ${kernelnumber};
	do	
		for c in ${cs};
		do
			for j in ${js};
			do
				for lambda in ${lambdas};
				do
					for mu in ${mus};
					do
						commands+="./${expType}_syntree_core.sh '${expType}' '${corpus}' '${j}' '${c}' '${lambda}' '${mu}'  '${inDir}' '${learner}' '${kernel}' '${tester}'"
						commands+="#"
					done
				done
			done
		done
	done
done

echo ${commands} | nice nice xargs --no-run-if-empty -d '#' -P ${numberofcores} --max-args 1 -t bash -c

echo "finished"
