#!/bin/bash

#./CV_SpT_core.sh '${expType}' '${corpus}' '${q}' '${c}' '${j}' '${u}' '${inDir}' '${learner}' '${tester}'

expType=$1; shift 1
corpus=$1; shift 1 
q=$1; shift 1
c=$1; shift 1
j=$1; shift 1
u=$1; shift 1
inDir=$1; shift 1
learner=$1; shift 1
tester=$1; shift 1

folds='0 1 2 3 4 5 6 7 8 9'
useFolds='0 1 2 3 4 5 6 7 8 9'

. kernelparams.sh

set -e

outDir=./${expType}/${corpus}/out-${expType}-${corpus}-q${q}-j${j}-c${c}
tmpDir=./${expType}/${corpus}/tmp-${expType}-${corpus}-q${q}-j${j}-c${c}

set +e
	rm -fR ${outDir}
	mkdir -p ${outDir}
set -e

logFile=${outDir}/${expType}-${corpus}-q${q}-j${j}-c${c}.log
echo "started: " | tee ${logFile}
date -R | tee -a ${logFile}

evalFile=${outDir}/${expType}-${corpus}-q${q}-j${j}-c${c}.sql
for fold in ${useFolds};
do
	echo "------------- extType=${expType}, corpus=${corpus}, parser=${combo}, q=${q}, c=${c}, j=${j}, u=${u}, fold=${fold}" | tee -a ${logFile}
	set +e
	rm -fR ${tmpDir}
	mkdir -p ${tmpDir}
	set -e
	learnCorpus=${tmpDir}/learn.txt
	testCorpus=${tmpDir}/test.txt
	
	# delete the current fold from folds
	learnFolds=${folds/$fold/}
						
	for learnFold in ${learnFolds};
	do
		cat ${inDir}/${learnFold}.txt.id >> ${learnCorpus}
	done
	cp ${inDir}/${fold}.txt.id ${testCorpus}
	model=${outDir}/${fold}-model.txt

	echo -n "insert into ppi${expType} (corpus, parsertype, parser, kernel, c, j, fold, kernel_script) values (" >> ${evalFile}
	echo "'${corpus}', '${parsertype}', '${combo}', '${kerneltext}', ${c}, ${j}, ${fold}, '${kernelscript}');" >> ${evalFile}

	#learn
	${learner} -v -1 -t ${kernel} -D ppi${expType} -u "${u},q=${q}" -c ${c} -j ${j} ${learnCorpus} ${model} >> ${evalFile}
	#test
	${tester} -v -1 -D ppi${expType} ${testCorpus} ${model} >> ${evalFile}

	sed -i 's/nan/0.0/g' ${evalFile}
done
set +e
	rm -fr ${tmpDir}
set -e

echo "finished: " | tee -a ${logFile}
date -R | tee -a ${logFile}

