#!/bin/bash

set -e

# import kernel-independent parameters

. ../config.sh 

# import kernel-dependent parameters

. config.sh

for corpus in ${allCorpora};
do
	# when CC then "location" is empty, otherwise, see below
	if [ ${expType} != "CC" ];
	then
		location=$corpus-folds 
	fi
	inDir=${corpusDir}/learning-format/${expType}/CUSTOM_KERNEL/${location}
	for q in ${qs};
	do
		for c in ${cs};
		do
			for j in ${js};
			do
				for u in ${us};
				do
					commands+="./${expType}_SpT_core.sh '${expType}' '${corpus}' '${q}' '${c}' '${j}' '${u}' '${inDir}' '${learner}' '${tester}'"
					commands+="#"
				done
			done
		done
	done
done

echo ${commands} | nice nice xargs --no-run-if-empty -d '#' -P ${numberofcores} --max-args 1 -t bash -c

echo "finished"