#!/usr/bin/python
#nice python run.py 1>run.out 2>run.err
import os
import glob
import subprocess
import re
import time
import math
import sys

from collections import deque
sys.path.append('..')
from editconfig import *
base= base+"CL/"

outFile= open(base +'CL.sql', 'w')
corpora= os.listdir(base+splits) #Contains all five corpora
regex = re.compile('\d+')
c = 0
for corpus in corpora:

    outFile.write ("-- Training on " +corpus +"\n")
    train= base +splits +os.sep +corpus +os.sep  +"train.txt"
    test= base +splits +os.sep +corpus +os.sep  +"eval.txt"
    pair= base +splits +os.sep +corpus +os.sep  +"pair.txt"

    for c in [0, 1, 10, 100]:
        start=time.time()
        job=subprocess.Popen(tsvm+"svm_learn -v 0 -t 4 -c " +str(c) +" " +train, shell=True)
        job.wait()
        end=time.time()

        outFile.write("INSERT INTO  ppiCL (corpus, parsertype, parser, kernel, c, kernel_script) values ('" +corpus +"', 'dependency', 'stanford-parser-2008-10-26', 'edit'," +str(c) +", 'edit;c=" +str(c) +"');\n")
        outFile.write("UPDATE ppiCL set learn_sec = "  +str(end-start)  +" where ppiCLid = currval('ppiCL_ppiCLid_seq');\n")

        job=subprocess.Popen(tsvm+"svm_classify -v -1 "  +test +" svm_model", shell=True,  stderr=subprocess.PIPE, stdout=subprocess.PIPE)
        string=""
        while True:
            out = job.stdout.read(1)
            if out == '' and job.poll() != None:
                break
            if out != '':
                string = string +out
        outFile.write(string.rstrip().replace("update exb set","update ppiCL set").replace("where exbid = currval('exb_exbid_seq')", "where ppiCLid = currval('ppiCL_ppiCLid_seq')\n"))

        pairs= deque([])
        f = open(pair, 'r')
        for line in f:
            pairs.append(line.rstrip())
        f.close()

        f= open('svm_predictions', 'r')
        for line in f:
            value= line.rstrip()
            if float(value) >= 0:
                bin= '1'
            else:
                bin= '0'
            outFile.write("INSERT INTO ppiCLoutput (expId, pair, output, prediction) values (currval('ppiCL_ppiCLid_seq'), '" +pairs.popleft() +"', '" +bin   +"', " +value +");\n")
        f.close()



