#!/usr/bin/python
#nice python run.py 1>run.out 2>run.err
import os
import glob
import subprocess
import re
import time
import math
import sys
import time
from collections import deque

sys.path.append('..')
from editconfig import *
base= base+"CV/"

#splits="parsed"
corpora= os.listdir(base+splits) #Contains all five corpora
outFile= open(base +'CV.sql', 'w')
regex = re.compile('\d+')
for corpus in reversed(corpora):
    
    for train in glob.glob(base +splits +os.sep +corpus +os.sep +"normal" +os.sep +"split*.train"): #Iterate over Traindata        
        fold= os.path.basename(train)
        fold= regex.search(os.path.basename(fold)).group(0) #For example train[0-9]

        outFile.write("-- " +corpus +" " +fold +"/9\n")
        test = base + splits +os.sep +corpus +os.sep +"normal" +os.sep +"split" +fold +".test"      #Trainfile
        pair = base + splits +os.sep +corpus +os.sep +"normal" +os.sep +"pair" +fold +".test"      #pairFile

        for c in [0, 1, 10, 100]:
#        for c in [0]:
            outFile.write("INSERT INTO ppiCV (parsertype, parser, corpus, fold, kernel, c, kernel_script) VALUES ('dependency', 'stanford-parser-2008-10-26', '" +corpus +"', " +fold+", 'edit'," +str(c) +",'edit; c=" +str(c) +"');\n")

            start=time.time()  
            job=subprocess.Popen(tsvm+"svm_learn -v 0 -t 4 -c " +str(c) +" " +train,shell=True)
            job.wait()
            end=time.time() 
            outFile.write("UPDATE ppiCV set learn_sec = " +str(end-start)  +" WHERE ppiCVid = currval('ppiCV_ppiCVid_seq');\n")

            job=subprocess.Popen(tsvm+"svm_classify -v -1 "  +test +" svm_model", shell=True,  stderr=subprocess.PIPE, stdout=subprocess.PIPE)
            string=""
            while True:
                out = job.stdout.read(1)
                if out == '' and job.poll() != None:
                    break
                if out != '':
                    string = string +out
#                    sys.stdout.write(out)
#                    sys.stdout.flush()
            outFile.write(string.rstrip().replace("update exb set","update ppiCV set").replace("where exbid = currval('exb_exbid_seq')", "where ppiCVid = currval('ppiCV_ppiCVid_seq')\n"))

            pairs= deque([])
            f = open(pair, 'r')
            for line in f:
                pairs.append(line.rstrip())
            f.close()
            
            f= open('svm_predictions', 'r')
            for line in f:
                value= line.rstrip()
                outFile.write("INSERT INTO ppiCVoutput (expId, pair, output, prediction) values (currval('ppiCV_ppiCVid_seq'), '" +pairs.popleft() +"', " +("'1'" if float(value) >= 0 else "'0'") +", " +value +");\n")
            f.close()            

outFile.close()
