#!/bin/bash

# ./CL_kBSPS_core.sh '${expType}' '${corpus}' '${j}' '${n}' '${t}' '${L}' '${E}' '${D}' '${l}' '${e}' '${d}' '${inDir}' '${learner}' '${tester}' '${kParam}'


expType=$1; shift 1
corpus=$1; shift 1
j=$1; shift 1
n=$1; shift 1
t=$1; shift 1
L=$1; shift 1
E=$1; shift 1
D=$1; shift 1
l=$1; shift 1
e=$1; shift 1
d=$1; shift 1
inDir=$1; shift 1
learner=$1; shift 1
tester=$1; shift 1
kParam=$1; shift 1

. kernelparams.sh

trains='AIMed BioInfer IEPA HPRD50 LLL'

set -e

outDir=./${expType}/temp/${corpus}/out-${expType}-${corpus}-${kParam}-${j}-LED-${L}${E}${D}${l}${e}${d}
tmpDir=./${expType}/temp/${corpus}/tmp-${expType}-${corpus}-${kParam}-${j}-LED-${L}${E}${D}${l}${e}${d}

LEDled="L=${L},E=${E},D=${D},l=${l},e=${e},d=${d}"
lmin=${kParam:0:1}
lmax=${kParam:3:1}
k=${kParam:6:1}
kernelscript="k-band(${kParam:0:4} k${k} match=${t})"

set +e
rm -fr ${outDir}
mkdir -p ${outDir}
rm -fr ${tmpDir}
mkdir -p ${tmpDir}
set -e
logFile=${outDir}/${expType}-${corpus}-${kParam}-${j}-LED-${L}${E}${D}${l}${e}${d}.log
echo "started: " | tee ${logFile}
date -R | tee -a ${logFile}
echo "------------- expType=${expType}, corpus=${corpus}, kernel=${kerneltext}, kParam = ${kParam}, j=${j}, n=${n}, t=${t}, ${LEDled}" | tee -a ${logFile}

learnCorpus=${tmpDir}/learn.txt
testCorpus=${tmpDir}/test.txt

cp ${inDir}/0.txt ${learnCorpus}
cp ${inDir}/1.txt ${testCorpus}

model=${outDir}/${corpus}-model.txt

evalFile=${outDir}/${expType}-${corpus}-${kParam}-${j}-LED-${L}${E}${D}${l}${e}${d}.sql

echo -n "insert into ppi${expType} (corpus, parsertype, parser, kernel, j, lmax, lmin, k, match_, normalized, input_format, led, c, kernel_script) values (" >> ${evalFile}
echo "'${corpus}', '${parsertype}', 'Charniak-Lease+Stanford converter', '${kerneltext}', ${j}, ${lmax}, ${lmin}, ${k}, '${t}', '${n}', '${inputFormat}', '${LEDled}', 0, '${kernelscript}');" >> ${evalFile}
#learn
${learner} -v -1 -D ppi${expType} -t ${kernel} -u "f=${inputFormat},N=${n},a=${lmax},i=${lmin},k=${k},t=${t},${LEDled}" -j ${j} -m 10000 ${learnCorpus} ${model} >> ${evalFile}
#eval
${tester} -v -1 -D ppi${expType} ${testCorpus} ${model} >> ${evalFile}

sed -i 's/nan/0.0/g' ${evalFile}

set +e
	rm -fr ${tmpDir}
set -e

echo "finished: " | tee -a ${logFile}
date -R | tee -a ${logFile}