#!/bin/bash

set -e

# import kernel-independent parameters

. ../config.sh 

# import kernel-dependent parameters

. config.sh

for kParam in ${kParams};
do
	for corpus in ${allCorpora};
	do
		# when CC then "location" is empty, otherwise, see below
		if [ ${expType} != "CC" ];
		then
			location=$corpus-folds 
		fi
		inDir=${corpusDir}/learning-format/${expType}/CUSTOM_KERNEL-b-${kParam}-UP_TO-OUTSIDE-NO_SELF_REF-STEM-none/${location}
		for j in ${js};
		do
			for n in ${ns};
			do
				for t in ${ts};
				do
					for L in ${Ls};
					do
						for E in ${Es};
						do
							for D in ${Ds};
							do
								for l in ${ls};
								do
									for e in ${es};
									do
										for d in ${ds};
										do
											commands+="./${expType}_kBSPS_core.sh '${expType}' '${corpus}' '${j}' '${n}' '${t}' '${L}' '${E}' '${D}' '${l}' '${e}' '${d}' '${inDir}' '${learner}' '${tester}' '${kParam}'"
											commands+="#"
										done
									done
								done
							done
						done
					done
				done
			done
		done
	done
done

echo ${commands} | nice nice xargs --no-run-if-empty -d '#' -P ${numberofcores} --max-args 1 -t bash -c

echo "finished"
