#!/usr/bin/perl -W -pi

$corpus = $1 if /teston\/(.+)\/svmModel/;

s/teston/cl/;

s/crossdataset/CL/;

($kernel,$experiment) = ($1,uc($2)) if /(syntactic|lexical|shallow|combined)\/(c[vlc])/;

s/(syntactic|lexical|shallow|combined)\/(c[vlc])/$experiment\/$1/ if /^(modelFile|outFile|trainKernel|testKernel|trainClassValues|testClassValues|testLabels|results|ids|rocSource)/;

$eof = 1 if eof;

if ($eof)
{
$experiment = uc $experiment;
%corpora = (
'aimed' => 'AImed',
'bioinfer' => 'BioInfer',
'hprd50' => 'HPRD50',
'iepa' => 'IEPA',
'lll' => 'LLL',
);
$corpus = $corpora{lc($corpus)} or warn "unknown corpus: $corpus\n";
print ARGVOUT <<EOF;


// auto-generated by $0

verbose		-1

outputType	DB
dbName		ppi$experiment
corpus		$corpus
c		1
kerneltype	$kernel

EOF
}
 
# SVMtrainexe 	resource/svm/svm-train.exe
# SVMtestexe 	resource/svm/svm-predict.exe
# modelFile	resource/syntactic/cv/lll/svmModel
# outFile		resource/syntactic/cv/lll/svmPrediction
# 
# //cv
# splits	resource/splits/lllsplits
# data	resource/lll.xml
# parse	resource/parse/lll
# 
# trainCVKernel	resource/syntactic/cv/lll/trainkernel
# testCVKernel	resource/syntactic/cv/lll/testkernel
# testLabels	resource/syntactic/cv/lll/testLabels
# results		resource/syntactic/cv/lll/results
# ids		resource/syntactic/cv/lll/ids
# 
# thresholdStep	0.1
# 
# rocSource	resource/syntactic/cv/lll/statistics/roc
# 
# suppressDirection	true
# 
# outputType	DB
# dbName		ppiCV
# corpus		LLL
