package client;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;

import java.util.logging.Level;
import java.util.logging.Logger;
import machinelearning.kernel.Kernel;
import deeper.Interaction;
import java.util.Collection;

import util.Params;

public class KernelBuilder {

    public static void buildKernel(Collection<Interaction> set1, Collection<Interaction> set2, String fileName, Kernel kernel) {
        PrintWriter writer= null;
        new File( new File(fileName).getParent()).mkdirs();
        try {
        	writer = new PrintWriter(fileName);
        } catch (FileNotFoundException ex) {
            Logger.getLogger(KernelBuilder.class.getName()).log(Level.SEVERE, null, ex);
            return;
        }
        int i = 1;
        for (Interaction i1 : set1) {
        	Params.addLog(3, String.valueOf("KernelBuilder.class:" + i1.id));
            writer.print(i1.status.ordinal());
            writer.print("\t");
            writer.print("0:" + Integer.toString(i++));
            writer.print("\t");
            int j = 1;
            for (Interaction i2 : set2) {
                double k = kernel.compute(i1, i2);
                writer.print(j++);
                if (k == 0) {
                    writer.print(":0");
                } else {
                    writer.print(":" + k);
                }
                writer.print("\t");
            }
            writer.println();
        }
        writer.close();
    }
}
