package corpus;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import java.util.ListIterator;
import parser.Parser;

import deeper.Interaction;

/**
 * Concrete composite class of the Composite pattern.
 * @author tfayruzo
 *
 */
public class Corpus extends CompositeText {
	
	public Corpus(String id){
		this.id = id;
	}

	@Override
	public Collection<Interaction> interactions() {
		List<Interaction> result = new ArrayList<Interaction>();
		for(Text child : children){
			Collection<Interaction> i = child.interactions();
			result.addAll(i);			
		}
		return result;
	}


	@Override
	public void parse(Parser parser, String...params) throws Exception{
		for(Text child : children){
			child.parse(parser, params);
		}
	}
}
