package machinelearning.kernel;

import deeper.Interaction;

import edu.uci.ics.jung.graph.DirectedEdge;
import edu.uci.ics.jung.graph.Vertex;
import graph.Keys;
import java.util.Iterator;

public class SyntacticKernel implements Kernel<Interaction>, Keys {
	
	@SuppressWarnings("unchecked")
	public double compute(Interaction i1, Interaction i2){
		double result = 0;
		if(i1.depPath == null || i2.depPath == null){
			return result;
		}
		for(Iterator it1 = i1.depPath.getVertices().iterator(); it1.hasNext();){
            Vertex v1 = (Vertex) it1.next();
			for(Iterator it2 = i2.depPath.getVertices().iterator(); it2.hasNext();){
                Vertex v2 = (Vertex) it2.next();
				result += Cm(v1,v2);
			}
		}
		return result;
	}
	
	private double Cm(Vertex v1, Vertex v2){
		double result = 1;
		if(v1.getOutEdges().size()>0 && v2.getOutEdges().size()>0){
			for(Object e1 : v1.getOutEdges()){
				for(Object e2 : v2.getOutEdges()){
					if(((DirectedEdge)e1).getUserDatum(Keys.LABEL).equals(((DirectedEdge)e2).getUserDatum(Keys.LABEL))){
						result *= (Cm(((DirectedEdge)e1).getDest(),((DirectedEdge)e2).getDest())+2);
					}
				}
			}
		}
		result--;
		return result;
	}
}
