package util;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintStream;
import java.io.PrintWriter;


public class Params {

		public static String propsFileName = "";
		
		public static String expDir = "";
		public static String expbaseDir = "";
		public static String baseDir = "";
		public static String LFDir = "";
		public static String corpDir = "";
		
		public static String expIdentifier = "";
		
		public enum ExperimentType {CV, CL, CC};	
		public static ExperimentType expType = ExperimentType.CV;
		public enum OutputType {Fayruzov, DB};
		public static OutputType outputType = OutputType.DB;
		public static String dbName = "CV";
		public static String PCFGfile = "resource/englishPCFG.ser.gz";
		public static String corpus = "";
		public static String testCorpus = "";
		public static String oldTestCorpus = "";
		public static String parser = "Stanford Parser 1.6.1";
		public static String kerneltype = "";
		public static String parsertype = "";
		public static String options = "";
		public static Double c = 1.0;
		public static Double j = 0.0;
		public static int fold = 0;
		
		public static String CCTrainTime = "";
		public static int verbose = 0;
		
		public static PrintStream logFile;
		
		public static PrintWriter sqlFile;
		
		//filenames
		
		public static String kernelClass = "";

		//classifier options
		public static String SVMtrainexe = "";
		public static String SVMtestexe = "";
		public static String modelFile = "";
		public static String outFile = "";

		public static String splits	= "";
		public static String data = "";
		public static String parse = "";

		public static String trainCVKernel = "";
		public static String testCVKernel = "";
		public static String testLabels = "";
		public static String results = "";
		public static String ids = ""; 

		public static double thresholdStep;

		public static String rocSource = "";

		public static String testSet = "";
		public static String trainSet = "";

		public static String trainKernel = "";
		public static String testKernel = "";
		public static String trainClassValues = "";
		public static String testClassValues = "";

		public static boolean suppressDirection = true;
		
		public static boolean errorAnalysis = true;
		
		public static String currID()
		{
			return "currval('" + dbName + "_" + dbName + "id_seq')";  
		}

		public static String printall()
		{
			return "expType: " + expType + "\n" +
					"baseDir: " + baseDir + "\n" +
					"LFDir (learning-format): " + LFDir + "\n" +
					"corpDir: " + corpDir + "\n" +
					"expbaseDir: " + expbaseDir + "\n" +
					"outputType: " + outputType + "\n" + 
					"dbName: " + dbName + "\n" + 
					"corpus: " + corpus + "\n" +
					"parser: " + parser + "\n" +
					"kerneltype: " + kerneltype + "\n" +
					"options: " + options + "\n" +
					"c: " + c + "\n" +
					"j: " + j + "\n" +
					"fold: " + fold + "\n\n" +
					"kernelClass: " + kernelClass + "\n" +
					"SVMtrainexe: " + SVMtrainexe + "\n" +
					"SVMtestexe: " + SVMtestexe + "\n" +
					"modelFile: " + modelFile + "\n" +
					"outFile: " + outFile + "\n" +
					"splits: " + splits + "\n" +
					"data: " + data + "\n" +
					"parse: " + parse + "\n" +
					"suppressDirection" + suppressDirection + "\n" +
					"trainCVKernel: " + trainCVKernel + "\n" +
					"testCVKernel: " + testCVKernel + "\n" +
					"testLabels: " + testLabels + "\n" +
					"results: " + results + "\n" +
					"ids: " + ids + "\n" +
					"thresholdStep: " + thresholdStep + "\n" +
					"rocSource: " + rocSource + "\n" +
					"trainSet: " + trainSet + "\n" +
					"testSet: " + testSet + "\n" +
					"trainKernel: " + trainKernel + "\n" +
					"testKernel: " + testKernel + "\n" +
					"trainClassValues: " + trainClassValues + "\n" +
					"testClassValues: " + testClassValues + "\n" +
					"verbose: " + verbose + "\n";
		}
		

		public static void addLog(int v, String str)
		{
			if ( verbose >= v ) {
				if (outputType.equals(OutputType.DB))
					{
					if ( logFile != null )
						logFile.println(str);
					else 
						throw new RuntimeException("Logfile does not exists: " + logFile);
					}
				else
					System.out.println(str);
			}
		}
		
		public static void createSQLFile() throws IOException
		{
			File myDir = new File(expDir + File.separator + expIdentifier);
			if (!myDir.exists())
				{
				myDir.mkdirs();
				addLog( -2, "Directory created: " + myDir);
				}
			else
			{
				addLog( -2, "Directory " + myDir + "already existed.");
			}
			addLog(-2, "Results written in: " + myDir + File.separator + expIdentifier + ".sql");
			sqlFile = new PrintWriter(myDir + File.separator + expIdentifier + ".sql");
		}

		public static void closeFiles()
		{
			if ( logFile != null ) {
            	logFile.flush();
            	logFile.close();
            	logFile = null;
			}
            if ( sqlFile != null ) {
            	sqlFile.flush();
            	sqlFile.close();
            	sqlFile = null;
            }
		}

}
