/* string_index.h
 *
 * Written by Peter Palaga, 2009-04-13
 *
 * Implementation of a simple table for replacing strings with integers.
 */


#ifndef STRING_INDEX_H
#define STRING_INDEX_H

#define string_index_max_capacity UINT_MAX
#define ZERO_INDEX 0

#include <limits.h>
#include <stdlib.h>

typedef unsigned int string_index_key_t;

typedef struct string_index {
  string_index_key_t expand_by;
  string_index_key_t capacity;
  string_index_key_t size;
  char** table;
} STRING_INDEX;

STRING_INDEX *create_string_index(string_index_key_t initial_capacity, string_index_key_t expand_by);
char* value_for_index(string_index_key_t index, STRING_INDEX* string_index);
string_index_key_t index_for_value(char* buffer, size_t len, unsigned char is_terminal, STRING_INDEX* string_index);

#endif




