package deeper;

import java.io.Serializable;

public class Protein implements Cloneable, Comparable, Serializable{
	
	private static final long serialVersionUID = 1L;

	//protein name bounds in the original sentence
	private int startOffset[];
	private int endOffset[];
	//protein name bounds in modified sentence
	private int startOffset_mod = -1;
	private int endOffset_mod = -1;
	//original name
	private String name;
	//modified name
	private String name_mod;
	private String type;
	//unique id (taken from PPI XML)
	private String id;
    public Protein equalsTo = null;
	
	@Override
	public Object clone(){
		try {
			return super.clone();
		} catch (CloneNotSupportedException e) {
			e.printStackTrace();
		}
		return null;
	}
	
	public boolean includes(Protein p){
		if(startOffset[0]<=p.startOffset[0] &&
			endOffset[endOffset.length-1]>=p.endOffset[p.endOffset.length-1]){
			return true;
		}
		return false;
	}

	@Override
	public int hashCode() {
		final int PRIME = 31;
		int result = 1;
		result = PRIME * result + endOffset[endOffset.length-1];
		result = PRIME * result + startOffset[0];
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Protein other = (Protein) obj;
        if(other.equalsTo != null)
            other = other.equalsTo;
        Protein thisOne = this;
        if(thisOne.equalsTo != null)
            thisOne = thisOne.equalsTo;
		if (thisOne.endOffset[thisOne.endOffset.length-1] != other.endOffset[other.endOffset.length-1])
			return false;
		if (thisOne.startOffset[0] != other.startOffset[0])
			return false;
		return true;
	}

    /*
     * CompareTo is not consistent with equals, because it does not take into
     * account 'equalsTo' field. It does not break anything now.
     */
	public int compareTo(Object arg0) {
		if(arg0 instanceof Protein){
			Protein p = (Protein) arg0;
			if(startOffset[0]>p.startOffset[0]){
				return 1;
			}else if(startOffset[0]<p.startOffset[0]){
				return -1;
			}else{
                if(endOffset[endOffset.length-1]>p.endOffset[p.endOffset.length-1]){
                    return -1;
                }else if(endOffset[endOffset.length-1]<p.endOffset[p.endOffset.length-1]){
                    return 1;
                }
            }
		}
		return 0;
	}
	
	public String toString(){
		return name+":"+name_mod;
	}

    public int[] getEndOffset() {
        return endOffset;
    }

    public void setEndOffset(int[] endOffset) {
        this.endOffset = endOffset;
    }

    public int getEndOffset_mod() {
        return endOffset_mod;
    }

    public void setEndOffset_mod(int endOffset_mod) {
        this.endOffset_mod = endOffset_mod;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getName_mod() {
        if(equalsTo != null)
            return equalsTo.name_mod;
        return name_mod;
    }

    public void setName_mod(String name_mod) {
        this.name_mod = name_mod;
    }

    public int[] getStartOffset() {
        return startOffset;
    }

    public void setStartOffset(int[] startOffset) {
        this.startOffset = startOffset;
    }

    public void setStartOffset(int i, int number) {
        this.startOffset[i] = number;
    }

    public void setEndOffset(int i, int number) {
        this.endOffset[i] = number;
    }

    public int getStartOffset(int i) {
        return startOffset[i];
    }

    public int getEndOffset(int i) {
        return endOffset[i];
    }

    public int getStartOffset_mod() {
        return startOffset_mod;
    }

    public void setStartOffset_mod(int startOffset_mod) {
        this.startOffset_mod = startOffset_mod;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }
}
